import { controls } from "./controls";
import { Event } from "./schema";
export declare abstract class base<T> {
    model: string;
    private baseType;
    protected _name: string;
    protected _elem: Element;
    protected _template: string;
    pivot: controls.pivot;
    constructor(model: string, baseType: string);
    protected attachPivot(elem: Element): controls.pivot;
    inject(type: string, method: string, func: Function): base<T>;
    on(method: Event, func: Function, overwrite?: boolean): base<T>;
    action(action: string, model: string, func: Function): base<T>;
    formatData(item: T, isTable?: boolean): string;
    clearAlerts(): void;
    showAlerts(className: string, txt: string, jsn?: any, xml?: XMLDocument): void;
    loadSelects(selects: NodeListOf<Element>, callback?: Function, reload?: boolean): void;
    clearFilters(selector: Element): void;
    shouldRoute(options: any): boolean;
}
