interface String {
    lower: () => string;
    upper: () => string;
    ltrim: () => string;
    rtrim: () => string;
    trim: () => string;
    startsWith: (part: string, pos?: number) => boolean;
    endsWith: (part: string, pos?: number) => boolean;
    capFirst: () => string;
    capWords: () => string;
    truncateWords: (number: number) => string;
    truncateWordsWithHtml: (number: number) => string;
    stripHtml: () => string;
    escapeHtml: () => string;
    toBool: () => boolean;
    contains: (val: string) => boolean;
    slugify: (lower?: boolean) => string;
    toPhoneNumber: () => string;
    getValueByKey: (key: string) => string;
    setValueByKey: (key: string, replacement: string) => string;
}
interface StringConstructor {
    isNullOrEmpty: (val: any) => boolean;
}
interface Number {
    toBool: () => boolean;
    random: (min: number, max: number) => number;
}
interface Array<T> {
    empty: () => Array<any>;
    isEmpty: () => boolean;
    each: (callback: Function) => void;
    remove: (item: any) => any;
    contains: (partial: string, strict: boolean) => boolean;
    indexOfPartial: (partial: string) => number;
    toObjectArray: (objName: string) => Array<any>;
}
interface Object {
    extend: (dest: any, src: any) => any;
}
interface Document {
    querySelector: (selector: string) => Element;
    querySelectorAll: (selector: string) => NodeListOf<Element>;
    create: (html: string) => Element;
}
interface NodeList {
    each: (callback: Function) => void;
    last: () => Element;
}
interface Element {
    attribute: (name: string, value?: string) => string & Element;
    parent: () => Element;
    first: (selector: string) => Element;
    append: (html: string) => Element;
    empty: () => Element;
    drop: () => Element;
    removeEvent: (event: string) => Element;
    addEvent: (event: string, callback: Function, overwrite?: boolean) => Element;
    show: (t?: string) => Element | void;
    hide: () => Element;
    toggle: () => Element;
    addClass: (className: string) => Element;
    removeClass: (className: string) => Element;
    asString: () => string;
    hasMatches: (selector: string) => boolean;
    up: (selector: string) => Element;
    isHidden: () => Boolean;
    val: (val?: string) => string;
}
interface HTMLElement {
    clean: () => HTMLElement;
    val: (val?: string) => string;
}
interface XMLHttpRequest {
    responseJSON?: () => JSON;
}
declare const _handlers: {};
declare function getElementValue(_self: any, val?: string): string;
declare function newGuid(): string;
