const _handlers = {};
function getElementValue(_self, val) {
    if (val != null) {
        if (_self.nodeName.lower() == "textarea") {
            _self.innerHTML = val;
            try {
                _self.innerText = val;
            }
            catch (e) { }
            try {
                _self.value = val;
            }
            catch (e) { }
        }
        else if (_self.nodeName.lower() == "input" && _self.attribute("type") != null) {
            switch (_self.attribute("type").lower()) {
                case "file":
                    break;
                case "checkbox":
                    if (val) {
                        _self.checked = true;
                    }
                    else {
                        _self.checked = false;
                    }
                    break;
                case "radio":
                    const name = _self.attribute("name");
                    const radios = document.querySelectorAll(`input[type='radio'][name='${name}']`);
                    radios.each(function (idx, elem) {
                        if (elem.attribute("value") == val) {
                            elem.checked = true;
                        }
                        else {
                            elem.checked = false;
                        }
                    });
                    break;
                case "date":
                    let date = val;
                    if (date.contains("T")) {
                        date = date.slice(0, date.indexOf("T"));
                    }
                    if (/\d{2}\/\d{2}\/\d{4}/g.test(val)) {
                        _self.value = `${date.slice(6, 10)}-${date.slice(0, 2)}-${date.slice(3, 5)}`;
                    }
                    else {
                        _self.value = date;
                    }
                    break;
                case "time":
                    const time = val;
                    if (/\d{2}:\d{2}:\d{2}/g.test(time)) {
                        _self.value = time.slice(0, 5);
                    }
                    else {
                        _self.value = time;
                    }
                    break;
                default:
                    _self.value = val;
                    break;
            }
        }
        else if (_self.nodeName.lower() == "select") {
            for (let i = 0; i < _self.options.length; i++) {
                if (_self.options[i].value == val) {
                    _self.selectedIndex = i;
                    break;
                }
            }
        }
    }
    else {
        if (_self.nodeName.lower() == "textarea") {
            try {
                return _self.value;
            }
            catch (e) { }
            if (_self.innerText != null && _self.innerText.trim() != "") {
                return _self.innerText;
            }
            else if (_self.innerHTML != null && _self.innerHTML.trim() != "") {
                return _self.innerHTML;
            }
            return null;
        }
        else if (_self.nodeName.lower() == "input" && _self.attribute("type") != null) {
            switch (_self.attribute("type").lower()) {
                case "checkbox":
                    return _self.checked;
                case "radio":
                    const name = _self.attribute("name");
                    return (document.querySelector(`input[type='radio'][name='${name}']:checked`) != null) ? document.querySelector(`input[type='radio'][name='${name}']:checked`).value : null;
                case "time":
                    return _self.value;
                default:
                    return _self.value;
            }
        }
        else if (_self.nodeName.lower() == "select") {
            if (_self.selectedIndex == -1) {
                return null;
            }
            else {
                if (_self.multiple) {
                    let values = "";
                    for (let i = 0; i < _self.options.length; i++) {
                        if (_self.options[i].selected) {
                            values += `${_self.options[i].value};`;
                        }
                    }
                    return values.slice(0, -1);
                }
                else {
                    return _self.options[_self.selectedIndex].value;
                }
            }
        }
    }
    return val;
}
function newGuid() {
    function generateGUIDPart() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (generateGUIDPart() + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + generateGUIDPart() + generateGUIDPart());
}
String.prototype.lower = function () {
    return this.toLowerCase();
};
String.prototype.upper = function () {
    return this.toUpperCase();
};
String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/g, "");
};
String.prototype.ltrim = function () {
    return this.replace(/^\s+/, "");
};
String.prototype.rtrim = function () {
    return this.replace(/\s+$/, "");
};
String.prototype.startsWith = function (part, pos) {
    return this.slice(0, part.length) == part;
};
String.prototype.endsWith = function (part, pos) {
    return this.slice(part.length) == part;
};
String.prototype.capFirst = function () {
    if (this.length == 1) {
        return this.toUpperCase();
    }
    else if (this.length > 0) {
        let regex = /^(\(|\[|"|')/;
        if (regex.test(this)) {
            return this.substring(0, 2).toUpperCase() + this.substring(2);
        }
        else {
            return this.substring(0, 1).toUpperCase() + this.substring(1);
        }
    }
    return null;
};
String.prototype.capWords = function () {
    let regexp = /\s/;
    let words = this.split(regexp);
    if (words.length == 1) {
        return words[0].capFirst();
    }
    else if (words.length > 1) {
        let result = '';
        for (let i = 0; i < words.length; i++) {
            if (words[i].capFirst() !== null) {
                result += words[i].capFirst() + ' ';
            }
        }
        result.trim();
        return result;
    }
    return null;
};
String.prototype.truncateWords = function (num) {
    let words = this.split(/\s+/);
    if (words.length > num) {
        return words.slice(0, num).join(' ');
    }
    return words.join(' ');
};
String.prototype.truncateWordsWithHtml = function (num) {
    let tags = [];
    let truncation = this.truncateWords(num);
    let matches = truncation.match(/<[\/]?([^> ]+)[^>]*>/g);
    for (let i = 0; i < matches.length; i++) {
        let opening = matches[i].replace('/', '');
        if (matches[i].indexOf('/') != -1 && tags.indexOf(opening) != -1) {
            tags.remove(opening);
        }
        else if (matches[i].indexOf('/') != -1) {
            continue;
        }
        else {
            tags.push(matches[i]);
        }
    }
    for (let i = 0; i < tags.length; i++) {
        truncation += tags[i].replace('<', '</').replace(/(\s*)(\w+)=("[^<>"]*"|'[^<>']*'|\w+)/g, '');
    }
    return truncation;
};
String.prototype.stripHtml = function () {
    let content = this.replace(/<[\/]?([^> ]+)[^>]*>/g, '');
    content = content.replace(/<style[^>]*>[\s\S]*?<\/style>/ig, '');
    content = content.replace(/<script[^>]*>[\s\S]*?<\/script>/ig, '');
    content = content.replace(/<!--[\s\S]*?-->/g, '');
    content = content.replace('&nbsp;', ' ');
    content = content.replace('&amp;', '&');
    return content;
};
String.prototype.escapeHtml = function () {
    let content = this.replace(/"/g, '&quot;');
    content.replace(/&(?!\w+;)/g, '&amp;');
    content.replace(/>/g, '&gt;');
    content.replace(/</g, '&lt;');
    return content;
};
String.prototype.toBool = function () {
    if (String.isNullOrEmpty(this)) {
        return false;
    }
    else if (this.lower() === "true" || this.lower() === "1" || this.lower() === "y" || this.lower() === "t") {
        return true;
    }
    return false;
};
String.prototype.contains = function (val) {
    if (this.indexOf(val) !== -1) {
        return true;
    }
    return false;
};
String.prototype.slugify = function (lower = true) {
    if (!lower) {
        return this.lower().normalize().replace(/[^a-z0-9]/gi, '-');
    }
    return this.normalize().replace(/[^a-z0-9]/gi, '-');
};
String.prototype.toPhoneNumber = function () {
    try {
        return this.substring(0, 3) + '-' + this.substring(3, 6) + '-' + this.substring(6);
    }
    catch (e) {
        return this;
    }
};
String.prototype.getValueByKey = function (key) {
    var collection = this.split(";");
    for (let i = 0; i < collection.length; i++) {
        if (collection[i].contains(":")) {
            let pairs = collection[i].split(":");
            if (pairs[0] == key) {
                return pairs[1];
            }
        }
    }
    return null;
};
String.prototype.setValueByKey = function (key, replacement) {
    var collection = this.split(";");
    var returnCollection = [];
    for (let i = 0; i < collection.length; i++) {
        if (collection[i].contains(":")) {
            let pairs = collection[i].split(":");
            if (pairs[0] == key) {
                pairs[1] = replacement;
            }
            returnCollection.push(pairs.join(":"));
        }
    }
    return returnCollection.join(';');
};
String.isNullOrEmpty = function (val) {
    if (val === undefined || val === null || val.trim() === '') {
        return true;
    }
    return false;
};
Number.prototype.toBool = function () {
    if (this === 0) {
        return false;
    }
    return true;
};
Number.random = function (min, max) {
    if (isNaN(min) || isNaN(max)) {
        throw 'Error: Only numbers are accepted as arguments.';
    }
    return Math.floor(Math.random() * (parseInt(max.toString(), 10) - parseInt(min.toString(), 10) + 1) + parseInt(min.toString(), 10));
};
Array.prototype.empty = function () {
    return this.splice(0, this.length);
};
Array.prototype.isEmpty = function () {
    if (this.length === 0) {
        return true;
    }
    return false;
};
Array.prototype.each = function (callback) {
    for (let i = 0; i < this.length; i++) {
        callback(i, this[i]);
    }
};
Array.prototype.remove = function (item) {
    let index = this.indexOf(item);
    if (index != -1) {
        return this.splice(index, 1);
    }
    return null;
};
Array.prototype.contains = function (partial, strict) {
    for (let i = 0; i < this.length; i++) {
        if (!strict && this[i].contains(partial)) {
            return true;
        }
        if (strict && this[i] === partial) {
            return true;
        }
    }
    return false;
};
Array.prototype.indexOfPartial = function (partial) {
    for (let i = 0; i < this.length; i++) {
        if (this[i].contains(partial)) {
            return i;
        }
    }
    return -1;
};
Array.prototype.toObjectArray = function (objName) {
    if (objName === undefined || objName === null) {
        throw 'Error: Property name must be provided for conversion.';
    }
    let items = this;
    if (typeof (items[0]) === 'string' || typeof (items[0]) === 'number' || typeof (items[0]) === 'boolean') {
        for (let i = 0; i < items.length; i++) {
            let val = items[i];
            items[i] = {};
            items[i][objName] = val;
        }
        return items;
    }
    else {
        return this;
    }
};
Object.extend = function (dest, src) {
    for (let prop in src) {
        if (src.hasOwnProperty(prop)) {
            dest[prop] = src[prop];
        }
    }
    return dest;
};
Document.prototype.create = function (html) {
    var placeholder = document.createElement("div");
    placeholder.innerHTML = html;
    return placeholder.childNodes[0];
};
NodeList.prototype.each = function (callback) {
    for (let i = 0; i < this.length; i++) {
        callback(i, this[i]);
    }
};
NodeList.prototype.last = function () {
    return this[this.length - 1];
};
Element.prototype.attribute = function (name, value) {
    if (value != null) {
        this.setAttribute(name, value);
        return this;
    }
    return this.getAttribute(name);
};
Element.prototype.parent = function () {
    return this.parentNode;
};
Element.prototype.hasMatches = function (selector) {
    if (this.matches != null) {
        return this.matches(selector);
    }
    else if (this.msMatchesSelector != null) {
        return this.msMatchesSelector(selector);
    }
    return false;
};
Element.prototype.up = function (selector) {
    var el = this;
    if (el.closest != null) {
        return el.closest(selector);
    }
    else {
        while (el) {
            if (el.hasMatches(selector)) {
                return el;
            }
            el = el.parentElement;
        }
    }
};
Element.prototype.first = function (selector) {
    function _decend(node) {
        let _currentNode = node;
        let nodeList = _currentNode.childNodes;
        for (let i = 0; i < nodeList.length; i++) {
            if (nodeList[i].nodeName.lower() === selector.lower()) {
                return nodeList[i];
            }
        }
        _decend(_currentNode);
    }
    return _decend(this);
};
Element.prototype.append = function (html) {
    this.insertAdjacentHTML('beforeend', html);
    return this;
};
Element.prototype.empty = function () {
    this.innerHTML = "";
    return this;
};
Element.prototype.drop = function () {
    var self = this;
    var parent = self.parentNode;
    parent.removeChild(self);
    return self;
};
Element.prototype.removeEvent = function (event) {
    if (this.id == "")
        return this;
    if (_handlers[this.id]) {
        if (_handlers[this.id][event]) {
            for (var i = 0; i < _handlers[this.id][event].length; i++)
                this.removeEventListener(event, _handlers[this.id][event][i]);
            _handlers[this.id][event].empty();
        }
    }
    return this;
};
Element.prototype.addEvent = function (event, callback, overwrite = false) {
    if (overwrite) {
        this.removeEvent(event);
    }
    this.addEventListener(event, callback);
    if (this.id == "") {
        this.id = newGuid();
    }
    if (!_handlers[this.id]) {
        _handlers[this.id] = {};
    }
    if (!_handlers[this.id][event]) {
        _handlers[this.id][event] = [];
    }
    _handlers[this.id][event].push(callback);
    return this;
};
Element.prototype.show = function (t = "block") {
    let styles = this.attribute("style");
    if (styles != null && styles != "") {
        return this.attribute("style", styles.setValueByKey("display", t));
    }
    return this.attribute("style", `display:${t}`);
};
Element.prototype.hide = function () {
    let styles = this.attribute("style");
    if (styles != null && styles != "") {
        return this.attribute("style", styles.setValueByKey("display", "none"));
    }
    return this.attribute("style", `display:none;`);
};
Element.prototype.toggle = function () {
    if (!(this.offsetWidth || this.offsetHeight || this.getClientRects().length)) {
        return this.show();
    }
    else {
        return this.hide();
    }
};
Element.prototype.addClass = function (className) {
    this.className += ` ${className}`;
    this.className = this.className.trim();
    return this;
};
Element.prototype.removeClass = function (className) {
    this.className = this.className.replace(className, "").normalize();
    return this;
};
Element.prototype.asString = function () {
    return this.outerHTML;
};
Element.prototype.isHidden = function () {
    return (this.offsetParent === null);
};
Element.prototype.val = function (val) {
    return getElementValue(this, val);
};
HTMLElement.prototype.clean = function () {
    this.value = this.value.replace(/\r?\n/g, "\r\n");
    return this;
};
HTMLElement.prototype.val = function (val) {
    return getElementValue(this, val);
};
XMLHttpRequest.prototype.responseJSON = function () {
    try {
        return JSON.parse(this.responseText);
    }
    catch (e) {
        return JSON.parse(`{ "data": "${this.responseText}" }`);
    }
};
//# sourceMappingURL=extenders.js.map