import { ListOptions } from "./schema";
import { base } from "./base";
export declare class lists {
    static bindAll(callback: Function): void;
}
export declare class list<T> extends base<T> {
    model: string;
    options: ListOptions;
    private _filters;
    private _items;
    private _form;
    id: string;
    gTypeName: string;
    recycleBin: Array<T>;
    currentPageIndex: number;
    pageSize: number;
    totalPageSize: number;
    totalCount: number;
    sortOrder: string;
    sortDirection: string;
    private _defaults;
    fetchURL: string;
    constructor(model: string, options?: ListOptions);
    init(): list<T>;
    private loadFilters(filters);
    private applyViewEvents();
    private withDefaults(parameters);
    populateListing(): void;
    undoLast(): void;
    callListing(): void;
    populateTable(selector: Element): void;
    clearTable(selector: Element): void;
    getRows(selector: string): number;
    setupPagingEvents(selector: Element, filters?: any): void;
    createPaging(selector: Element, totalCount: any, filters?: any): void;
    private applyPageSizeEvents(selector);
    private calculateTotalPageSize(totalCount);
    private pageListing(idx, filters?);
    private getPreviousPage();
    private getNextPage();
    private setFilters();
    elem: Element;
    form: string;
    filters: T;
}
