var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
String.prototype.lower = function () {
    return this.toLowerCase();
};
String.prototype.upper = function () {
    return this.toUpperCase();
};
String.prototype.trim = function () {
    return this.replace(/^\s+|\s+$/g, "");
};
String.prototype.ltrim = function () {
    return this.replace(/^\s+/, "");
};
String.prototype.rtrim = function () {
    return this.replace(/\s+$/, "");
};
String.prototype.normalize = function () {
    return this.replace(/^\s*|\s(?=\s)|\s*$/g, "");
};
String.prototype.startsWith = function (part) {
    return this.slice(0, part.length) == part;
};
String.prototype.endsWith = function (part) {
    return this.slice(part.length) == part;
};
String.prototype.capFirst = function () {
    if (this.length == 1) {
        return this.toUpperCase();
    }
    else if (this.length > 0) {
        var regex = /^(\(|\[|"|')/;
        if (regex.test(this)) {
            return this.substring(0, 2).toUpperCase() + this.substring(2);
        }
        else {
            return this.substring(0, 1).toUpperCase() + this.substring(1);
        }
    }
    return null;
};
String.prototype.capWords = function () {
    var regexp = /\s/;
    var words = this.split(regexp);
    if (words.length == 1) {
        return words[0].capFirst();
    }
    else if (words.length > 1) {
        var result = '';
        for (var i = 0; i < words.length; i++) {
            if (words[i].capFirst() !== null) {
                result += words[i].capFirst() + ' ';
            }
        }
        result.trim();
        return result;
    }
    return null;
};
String.prototype.truncateWords = function (num) {
    var words = this.split(/\s+/);
    if (words.length > num) {
        return words.slice(0, num).join(' ');
    }
    return words.join(' ');
};
String.prototype.truncateWordsWithHtml = function (num) {
    var tags = [];
    var truncation = this.truncateWords(num);
    var matches = truncation.match(/<[\/]?([^> ]+)[^>]*>/g);
    for (var i = 0; i < matches.length; i++) {
        var opening = matches[i].replace('/', '');
        if (matches[i].indexOf('/') != -1 && tags.indexOf(opening) != -1) {
            tags.remove(opening);
        }
        else if (matches[i].indexOf('/') != -1) {
            continue;
        }
        else {
            tags.push(matches[i]);
        }
    }
    for (var i = 0; i < tags.length; i++) {
        truncation += tags[i].replace('<', '</').replace(/(\s*)(\w+)=("[^<>"]*"|'[^<>']*'|\w+)/g, '');
    }
    return truncation;
};
String.prototype.stripHtml = function () {
    var content = this.replace(/<[\/]?([^> ]+)[^>]*>/g, '');
    content = content.replace(/<style[^>]*>[\s\S]*?<\/style>/ig, '');
    content = content.replace(/<script[^>]*>[\s\S]*?<\/script>/ig, '');
    content = content.replace(/<!--[\s\S]*?-->/g, '');
    content = content.replace('&nbsp;', ' ');
    content = content.replace('&amp;', '&');
    return content;
};
String.prototype.escapeHtml = function () {
    var content = this.replace(/"/g, '&quot;');
    content.replace(/&(?!\w+;)/g, '&amp;');
    content.replace(/>/g, '&gt;');
    content.replace(/</g, '&lt;');
    return content;
};
String.prototype.toBool = function () {
    if (String.isNullOrEmpty(this)) {
        return false;
    }
    else if (this.lower() === "true" || this.lower() === "1" || this.lower() === "y" || this.lower() === "t") {
        return true;
    }
    return false;
};
String.prototype.contains = function (val) {
    if (this.indexOf(val) !== -1) {
        return true;
    }
    return false;
};
String.prototype.slugify = function (lower) {
    if (lower === void 0) { lower = true; }
    if (!lower) {
        return this.lower().normalize().replace(/[^a-z0-9]/gi, '-');
    }
    return this.normalize().replace(/[^a-z0-9]/gi, '-');
};
String.prototype.toPhoneNumber = function () {
    try {
        return this.substring(0, 3) + '-' + this.substring(3, 6) + '-' + this.substring(6);
    }
    catch (e) {
        return this;
    }
};
String.prototype.getValueByKey = function (key) {
    var collection = this.split(";");
    for (var i = 0; i < collection.length; i++) {
        if (collection[i].contains(":")) {
            var pairs = collection[i].split(":");
            if (pairs[0] == key) {
                return pairs[1];
            }
        }
    }
    return null;
};
String.prototype.setValueByKey = function (key, replacement) {
    var collection = this.split(";");
    var returnCollection = [];
    for (var i = 0; i < collection.length; i++) {
        if (collection[i].contains(":")) {
            var pairs = collection[i].split(":");
            if (pairs[0] == key) {
                pairs[1] = replacement;
            }
            returnCollection.push(pairs.join(":"));
        }
    }
    return returnCollection.join(';');
};
String.isNullOrEmpty = function (val) {
    if (val === undefined || val === null || val.trim() === '') {
        return true;
    }
    return false;
};
Number.prototype.toBool = function () {
    if (this === 0) {
        return false;
    }
    return true;
};
Number.random = function (min, max) {
    if (isNaN(min) || isNaN(max)) {
        throw 'Error: Only numbers are accepted as arguments.';
    }
    return Math.floor(Math.random() * (parseInt(max.toString(), 10) - parseInt(min.toString(), 10) + 1) + parseInt(min.toString(), 10));
};
Array.prototype.empty = function () {
    return this.splice(0, this.length);
};
Array.prototype.isEmpty = function () {
    if (this.length === 0) {
        return true;
    }
    return false;
};
Array.prototype.each = function (callback) {
    for (var i = 0; i < this.length; i++) {
        callback(i, this[i]);
    }
};
Array.prototype.remove = function (item) {
    var index = this.indexOf(item);
    if (index != -1) {
        return this.splice(index, 1);
    }
    return null;
};
Array.prototype.contains = function (partial, strict) {
    for (var i = 0; i < this.length; i++) {
        if (!strict && this[i].contains(partial)) {
            return true;
        }
        if (strict && this[i] === partial) {
            return true;
        }
    }
    return false;
};
Array.prototype.indexOfPartial = function (partial) {
    for (var i = 0; i < this.length; i++) {
        if (this[i].contains(partial)) {
            return i;
        }
    }
    return -1;
};
Array.prototype.toObjectArray = function (objName) {
    if (objName === undefined || objName === null) {
        throw 'Error: Property name must be provided for conversion.';
    }
    var items = this;
    if (typeof (items[0]) === 'string' || typeof (items[0]) === 'number' || typeof (items[0]) === 'boolean') {
        for (var i = 0; i < items.length; i++) {
            var val = items[i];
            items[i] = {};
            items[i][objName] = val;
        }
        return items;
    }
    else {
        return this;
    }
};
Object.extend = function (dest, src) {
    for (var prop in src) {
        if (src.hasOwnProperty(prop)) {
            dest[prop] = src[prop];
        }
    }
    return dest;
};
Document.prototype.selectOne = function (selector) {
    return document.querySelector(selector);
};
Document.prototype.selectAll = function (selector) {
    return document.querySelectorAll(selector);
};
Document.prototype.create = function (html) {
    var placeholder = document.createElement("div");
    placeholder.innerHTML = html;
    return placeholder.childNodes[0];
};
NodeList.prototype.each = function (callback) {
    for (var i = 0; i < this.length; i++) {
        callback(i, this[i]);
    }
};
NodeList.prototype.last = function () {
    return this[this.length - 1];
};
Element.prototype.selectOne = function (selector) {
    return this.querySelector(selector);
};
Element.prototype.selectAll = function (selector) {
    return this.querySelectorAll(selector);
};
Element.prototype.attribute = function (name, value) {
    if (value != null) {
        this.setAttribute(name, value);
        return this;
    }
    return this.getAttribute(name);
};
Element.prototype.parent = function () {
    return this.parentNode;
};
Element.prototype.hasMatches = function (selector) {
    if (this.matches != null) {
        return this.matches(selector);
    }
    else if (this.msMatchesSelector != null) {
        return this.msMatchesSelector(selector);
    }
    return false;
};
Element.prototype.up = function (selector) {
    var el = this;
    if (el.closest != null) {
        return el.closest(selector);
    }
    else {
        while (el) {
            if (el.hasMatches(selector)) {
                return el;
            }
            el = el.parentElement;
        }
    }
};
Element.prototype.first = function (selector) {
    function _decend(node) {
        var _currentNode = node;
        var nodeList = _currentNode.childNodes;
        for (var i = 0; i < nodeList.length; i++) {
            if (nodeList[i].nodeName.lower() === selector.lower()) {
                return nodeList[i];
            }
        }
        _decend(_currentNode);
    }
    return _decend(this);
};
Element.prototype.append = function (html) {
    this.insertAdjacentHTML('beforeend', html);
    return this;
};
Element.prototype.empty = function () {
    this.innerHTML = "";
    return this;
};
Element.prototype.drop = function () {
    var self = this;
    var parent = self.parentNode;
    parent.removeChild(self);
    return self;
};
Element.prototype.removeEvent = function (event) {
    if (this.id == "")
        return this;
    if (metron.globals.handlers[this.id]) {
        if (metron.globals.handlers[this.id][event]) {
            for (var i = 0; i < metron.globals.handlers[this.id][event].length; i++)
                this.removeEventListener(event, metron.globals.handlers[this.id][event][i]);
            metron.globals.handlers[this.id][event].empty();
        }
    }
    return this;
};
Element.prototype.addEvent = function (event, callback, overwrite) {
    if (overwrite === void 0) { overwrite = false; }
    if (overwrite) {
        this.removeEvent(event);
    }
    this.addEventListener(event, callback);
    if (this.id == "") {
        this.id = metron.guid.newGuid();
    }
    if (!metron.globals.handlers[this.id]) {
        metron.globals.handlers[this.id] = {};
    }
    if (!metron.globals.handlers[this.id][event]) {
        metron.globals.handlers[this.id][event] = [];
    }
    metron.globals.handlers[this.id][event].push(callback);
    return this;
};
Element.prototype.show = function (t) {
    if (t === void 0) { t = "block"; }
    var styles = this.attribute("style");
    if (styles != null && styles != "") {
        return this.attribute("style", styles.setValueByKey("display", t));
    }
    return this.attribute("style", "display:" + t);
};
Element.prototype.hide = function () {
    var styles = this.attribute("style");
    if (styles != null && styles != "") {
        return this.attribute("style", styles.setValueByKey("display", "none"));
    }
    return this.attribute("style", "display:none;");
};
Element.prototype.toggle = function () {
    if (!(this.offsetWidth || this.offsetHeight || this.getClientRects().length)) {
        return this.show();
    }
    else {
        return this.hide();
    }
};
Element.prototype.addClass = function (className) {
    this.className += " " + className;
    this.className = this.className.trim();
    return this;
};
Element.prototype.removeClass = function (className) {
    this.className = this.className.replace(className, "").normalize();
    return this;
};
Element.prototype.asString = function () {
    return this.outerHTML;
};
Element.prototype.isHidden = function () {
    return (this.offsetParent === null);
};
HTMLElement.prototype.clean = function () {
    this.value = this.value.replace(/\r?\n/g, "\r\n");
    return this;
};
HTMLElement.prototype.val = function (val) {
    if (val != null) {
        if (this.nodeName.lower() == "textarea") {
            this.innerHTML = val;
            try {
                this.innerText = val;
            }
            catch (e) { }
            try {
                this.value = val;
            }
            catch (e) { }
        }
        else if (this.nodeName.lower() == "input" && this.attribute("type") != null) {
            switch (this.attribute("type").lower()) {
                case "file":
                    break;
                case "checkbox":
                    if (val) {
                        this.checked = true;
                    }
                    else {
                        this.checked = false;
                    }
                    break;
                case "radio":
                    var name_1 = this.attribute("name");
                    var radios = document.selectAll("input[type='radio'][name='" + name_1 + "']");
                    radios.each(function (idx, elem) {
                        if (elem.attribute("value") == val) {
                            elem.checked = true;
                        }
                        else {
                            elem.checked = false;
                        }
                    });
                    break;
                case "date":
                    var date = val;
                    if (date.contains("T")) {
                        date = date.slice(0, date.indexOf("T"));
                    }
                    if (metron.globals.requiresDateTimePolyfill && /\d{4}-\d{2}-\d{2}/g.test(val)) {
                        this.value = date.slice(5, 7) + "/" + date.slice(8, 10) + "/" + date.slice(0, 4);
                    }
                    else if (metron.globals.requiresDateTimePolyfill && /\d{2}\/\d{2}\/\d{4}/g.test(val)) {
                        this.value = date;
                    }
                    else if (/\d{2}\/\d{2}\/\d{4}/g.test(val)) {
                        this.value = date.slice(6, 10) + "-" + date.slice(0, 2) + "-" + date.slice(3, 5);
                    }
                    else {
                        this.value = date;
                    }
                    break;
                case "time":
                    var time = val;
                    if (metron.globals.requiresDateTimePolyfill) {
                        if (/\d{2}:\d{2}:\d{2}/g.test(time)) {
                            var hour = Number(time.slice(0, 2));
                            var period = hour > 11 ? "PM" : "AM";
                            hour = hour > 12 ? hour - 12 : hour;
                            var hourStr = hour > 9 ? hour.toString() : "0" + hour.toString();
                            this.value = hourStr + ":" + time.slice(3, 5) + " " + period;
                        }
                        else {
                            this.value = time;
                        }
                    }
                    else {
                        if (/\d{2}:\d{2}:\d{2}/g.test(time)) {
                            this.value = time.slice(0, 5);
                        }
                        else {
                            this.value = time;
                        }
                    }
                    break;
                default:
                    this.value = val;
                    break;
            }
        }
        else if (this.nodeName.lower() == "select") {
            for (var i = 0; i < this.options.length; i++) {
                if (this.options[i].value == val) {
                    this.selectedIndex = i;
                    break;
                }
            }
        }
    }
    else {
        if (this.nodeName.lower() == "textarea") {
            try {
                return this.value;
            }
            catch (e) { }
            if (this.innerText != null && this.innerText.trim() != "") {
                return this.innerText;
            }
            else if (this.innerHTML != null && this.innerHTML.trim() != "") {
                return this.innerHTML;
            }
            return null;
        }
        else if (this.nodeName.lower() == "input" && this.attribute("type") != null) {
            switch (this.attribute("type").lower()) {
                case "checkbox":
                    return this.checked;
                case "radio":
                    var name_2 = this.attribute("name");
                    return document.selectOne("input[type='radio'][name='" + name_2 + "']:checked").value;
                case "time":
                    if (metron.globals.requiresDateTimePolyfill && /\d{2}:\d{2} \S{2}/g.test(this.value)) {
                        var period = this.value.slice(6, 8);
                        var hour = Number(this.value.slice(0, 2));
                        var hourStr = (period == "PM" && hour < 12) ? (hour + 12).toString() : hour.toString();
                        return hourStr + ":" + this.value.slice(3, 5) + ":00";
                    }
                    else {
                        return this.value;
                    }
                default:
                    return this.value;
            }
        }
        else if (this.nodeName.lower() == "select") {
            return this.options[this.selectedIndex].value;
        }
    }
    return val;
};
XMLHttpRequest.prototype.responseJSON = function () {
    return JSON.parse(this.responseText);
};
var metron;
(function (metron) {
    var OptionTypes;
    (function (OptionTypes) {
        OptionTypes[OptionTypes["QUERYSTRING"] = 1] = "QUERYSTRING";
        OptionTypes[OptionTypes["KEYVALUE"] = 2] = "KEYVALUE";
    })(OptionTypes = metron.OptionTypes || (metron.OptionTypes = {}));
    var Event;
    (function (Event) {
        Event[Event["INIT"] = 0] = "INIT";
        Event[Event["LOAD_FILTERS"] = 1] = "LOAD_FILTERS";
        Event[Event["APPLY_VIEW_EVENTS"] = 2] = "APPLY_VIEW_EVENTS";
        Event[Event["POPULATE_LISTING"] = 3] = "POPULATE_LISTING";
        Event[Event["UNDO_LAST"] = 4] = "UNDO_LAST";
        Event[Event["CALL_LISTING"] = 5] = "CALL_LISTING";
        Event[Event["SAVE"] = 6] = "SAVE";
        Event[Event["LOAD_FORM"] = 7] = "LOAD_FORM";
        Event[Event["LOAD_SELECTS"] = 8] = "LOAD_SELECTS";
        Event[Event["CLEAR_FORM"] = 9] = "CLEAR_FORM";
        Event[Event["NEW"] = 10] = "NEW";
        Event[Event["UNDO"] = 11] = "UNDO";
        Event[Event["DOWNLOAD"] = 12] = "DOWNLOAD";
        Event[Event["EDIT"] = 13] = "EDIT";
        Event[Event["DELETE"] = 14] = "DELETE";
        Event[Event["CANCEL"] = 15] = "CANCEL";
    })(Event = metron.Event || (metron.Event = {}));
    metron.LIST = "list";
    metron.LOOKUP = "lookup";
    metron.FORM = "form";
    metron.VIEW = "view";
    metron.INFO = "info";
    metron.WARNING = "warning";
    metron.DANGER = "danger";
    metron.SUCCESS = "success";
    metron.DB = "metron.db";
    metron.DBVERSION = 1;
    metron.STORE = "metron.store";
})(metron || (metron = {}));
var metron;
(function (metron) {
    var dictionary;
    (function (dictionary_1) {
        (function () {
            function dictionary(obj) {
                this.length = 0;
                this.items = {};
                if (obj !== null) {
                    for (var prop in obj) {
                        if (obj.hasOwnProperty(prop)) {
                            this.items[prop] = obj[prop];
                            this.length++;
                        }
                    }
                }
            }
            dictionary.prototype.setItem = function (key, value) {
                if (!this.hasItem(key)) {
                    this.length++;
                }
                this.items[key] = value;
            };
            dictionary.prototype.getItem = function (key) {
                return this.hasItem(key) ? this.items[key] : null;
            };
            dictionary.prototype.hasItem = function (key) {
                return this.items.hasOwnProperty(key);
            };
            dictionary.prototype.removeItem = function (key) {
                if (this.hasItem(key)) {
                    this.length--;
                    var item = this.items[key];
                    delete this.items[key];
                    return item;
                }
                else {
                    return null;
                }
            };
            dictionary.prototype.keys = function () {
                var keys = [];
                for (var k in this.items) {
                    if (this.hasItem(k)) {
                        keys.push(k);
                    }
                }
                return keys;
            };
            dictionary.prototype.values = function () {
                var values = [];
                for (var k in this.items) {
                    if (this.hasItem(k)) {
                        values.push(this.items[k]);
                    }
                }
                return values;
            };
            dictionary.prototype.each = function (callback) {
                var i = 0;
                for (var key in this.items) {
                    callback(i, key, this.items[key]);
                    i++;
                }
            };
            dictionary.prototype.clear = function () {
                this.items = {};
                this.length = 0;
            };
            return dictionary;
        })();
    })(dictionary = metron.dictionary || (metron.dictionary = {}));
    var web;
    (function (web) {
        function parseUrl(url, obj, encode) {
            if (encode === void 0) { encode = false; }
            var paramPairs = [];
            if (url.contains('?')) {
                var parts = url.split('?');
                url = parts[0];
                paramPairs = paramPairs.concat(parts[1].split('&'));
            }
            for (var prop in obj) {
                if (obj.hasOwnProperty(prop) && !paramPairs.contains(prop, true)) {
                    var item = (encode) ? encodeURIComponent(obj[prop]) : obj[prop];
                    paramPairs.push(prop + '=' + item);
                }
                else if (obj.hasOwnProperty(prop) && paramPairs.contains(prop, true)) {
                    var item = (encode) ? encodeURIComponent(obj[prop]) : obj[prop];
                    paramPairs[paramPairs.indexOfPartial(prop)] = prop + '=' + item;
                }
            }
            return url + '?' + paramPairs.join('&');
        }
        function querystring(obj) {
            if (typeof (document) !== 'undefined') {
                if (typeof (obj) === 'string' && arguments.length === 1) {
                    var result = [];
                    var match = void 0;
                    var re = new RegExp('(?:\\?|&)' + obj + '=(.*?)(?=&|$)', 'gi');
                    while ((match = re.exec(document.location.search)) !== null) {
                        result.push(match[1]);
                    }
                    return result;
                }
                else if (typeof (obj) === 'string' && arguments.length > 1) {
                    return [parseUrl(obj, arguments[1])];
                }
                else if (obj != null) {
                    return [parseUrl(document.location.href, obj)];
                }
                else {
                    return document.location.search.substring(1);
                }
            }
            else {
                throw 'Error: No document object found. Environment may not contain a DOM.';
            }
        }
        web.querystring = querystring;
        function querystringify(obj, encode) {
            if (encode === void 0) { encode = false; }
            return parseUrl("", obj, encode);
        }
        web.querystringify = querystringify;
        var cookie;
        (function (cookie_1) {
            function get(name) {
                if (typeof (document) !== 'undefined') {
                    var cookieParts = document.cookie.split(';');
                    for (var i = 0; i < cookieParts.length; i++) {
                        var cookieName = cookieParts[i].substr(0, cookieParts[i].indexOf("="));
                        var cookieValue = cookieParts[i].substr(cookieParts[i].indexOf("=") + 1);
                        if (cookieName.trim() === name) {
                            return cookieValue;
                        }
                    }
                    return null;
                }
                else {
                    throw 'Error: No document object found. Environment may not contain a DOM.';
                }
            }
            cookie_1.get = get;
            function set(name, val, date) {
                if (typeof (document) !== 'undefined') {
                    var cookie_2 = name + '=' + val + ';path="/"';
                    if (typeof (date) !== 'undefined') {
                        cookie_2 += ';expires=' + date.toUTCString();
                    }
                    document.cookie = cookie_2;
                }
                else {
                    throw 'Error: No document object found. Environment may not contain a DOM.';
                }
            }
            cookie_1.set = set;
            function remove(name) {
                if (typeof (document) !== 'undefined') {
                    document.cookie = name + "=; expires=Thu, 01 Jan 1970 00:00:00 UTC";
                }
                else {
                    throw 'Error: No document object found. Environment may not contain a DOM.';
                }
            }
            cookie_1.remove = remove;
        })(cookie = web.cookie || (web.cookie = {}));
        var headers;
        (function (headers) {
            function get(name) {
                if (typeof (document) !== 'undefined') {
                    var request = new XMLHttpRequest();
                    request.open("HEAD", document.location.href, false);
                    request.send(null);
                    if (name !== undefined) {
                        return request.getResponseHeader(name);
                    }
                    else {
                        return request.getAllResponseHeaders();
                    }
                }
                else {
                    throw 'Error: No document object found. Environment may not contain a DOM.';
                }
            }
            headers.get = get;
        })(headers = web.headers || (web.headers = {}));
        function ajax(url, data, method, async, contentType, dataType, success, failure, always) {
            if (data === void 0) { data = {}; }
            if (method === void 0) { method = "POST"; }
            if (async === void 0) { async = true; }
            if (contentType === void 0) { contentType = "application/x-www-form-urlencoded; charset=UTF-8"; }
            if (dataType === void 0) { dataType = "text"; }
            function _parseResult(request) {
                switch (dataType.lower()) {
                    case "text":
                        return request.responseText;
                    case "json":
                        return request.responseJSON();
                    case "xml":
                        return request.responseXML;
                    default:
                        return request.responseText;
                }
            }
            function _send(request, data) {
                var ajx = this;
                request.open(method, url, async, data);
                request.onreadystatechange = function () {
                    if (request.readyState === 4) {
                        if (request.status === 200) {
                            if (success !== undefined) {
                                success(_parseResult(request));
                            }
                        }
                        if (request.status === 404 || request.status === 405 || request.status === 500) {
                            if (failure !== undefined) {
                                failure(request.responseText, request.responseJSON(), request.responseXML);
                            }
                            else {
                                document.selectOne("[data-m-segment='alert']").addClass("danger").innerHTML = "<p>" + ((request.responseText != null && request.responseText != "") ? request.responseText : "Error: A problem has occurred while attempting to complete the last operation!") + "</p>";
                                document.selectOne("[data-m-segment='alert']").show();
                            }
                        }
                        if (always !== undefined) {
                            always(request);
                        }
                    }
                };
                request.setRequestHeader("Content-Type", contentType);
                if (url.contains("localhost")) {
                    request.setRequestHeader("Cache-Control", "max-age=0");
                }
                request.send(data);
            }
            var request = new XMLHttpRequest();
            var requestData = (typeof (data) !== "string") ? metron.web.querystringify(data, true) : data;
            if (requestData.startsWith("?")) {
                requestData = requestData.substr(1);
            }
            if (requestData.endsWith("?")) {
                requestData = requestData.substr(0, requestData.length - 2);
            }
            var self = {
                url: url,
                method: method,
                contentType: contentType,
                dataType: dataType,
                data: requestData,
                async: async,
                request: request,
                send: function () {
                    _send(request, requestData);
                }
            };
            if (success != null || failure != null || always != null) {
                self.send();
            }
            return self;
        }
        web.ajax = ajax;
        function get(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/x-www-form-urlencoded; charset=UTF-8"; }
            return ajax(url, params, "GET", true, (contentType != null) ? contentType : "application/x-www-form-urlencoded; charset=UTF-8", dataType, success, failure, always);
        }
        web.get = get;
        function post(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/x-www-form-urlencoded; charset=UTF-8"; }
            return ajax(url, params, "POST", true, (contentType != null) ? contentType : "application/x-www-form-urlencoded; charset=UTF-8", dataType, success, failure, always);
        }
        web.post = post;
        function postAll(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/json;charset=utf-8"; }
            return ajax(url, JSON.stringify({ "data": params }), "POST", true, (contentType != null) ? contentType : "application/json;charset=utf-8", dataType, success, failure, always);
        }
        web.postAll = postAll;
        function put(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/x-www-form-urlencoded; charset=UTF-8"; }
            return ajax(url, params, "PUT", true, (contentType != null) ? contentType : "application/x-www-form-urlencoded; charset=UTF-8", dataType, success, failure, always);
        }
        web.put = put;
        function putAll(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/json;charset=utf-8"; }
            return ajax(url, JSON.stringify({ "data": params }), "PUT", true, (contentType != null) ? contentType : "application/json;charset=utf-8", dataType, success, failure, always);
        }
        web.putAll = putAll;
        function remove(url, params, contentType, dataType, success, failure, always) {
            if (params === void 0) { params = {}; }
            if (contentType === void 0) { contentType = "application/x-www-form-urlencoded; charset=UTF-8"; }
            return ajax(url, params, "DELETE", true, (contentType != null) ? contentType : "application/x-www-form-urlencoded; charset=UTF-8", dataType, function (data) {
                if (data != null && data instanceof Array && data.length > 0) {
                    success(data[0]);
                }
                else {
                    success(data);
                }
            }, failure, always);
        }
        web.remove = remove;
    })(web = metron.web || (metron.web = {}));
    var observer;
    (function (observer) {
        (function () {
            var callback;
            var frequency;
            var isExecuting = false;
            var timer;
            function setupInterval(pe) {
                timer = setInterval(function () {
                    pe.onTimer(pe);
                }, frequency * 1000);
            }
            function execute(pe) {
                callback(pe);
            }
            function onTimer(pe) {
                if (!isExecuting) {
                    try {
                        isExecuting = true;
                        execute(pe);
                        isExecuting = false;
                    }
                    catch (e) {
                        isExecuting = false;
                        throw e;
                    }
                }
            }
            return {
                watch: function (callback, frequency) {
                    this.callback = callback;
                    this.frequency = frequency;
                    this.setupInterval(this);
                },
                stop: function () {
                    if (!timer) {
                        return;
                    }
                    clearInterval(timer);
                    timer = null;
                }
            };
        })();
    })(observer = metron.observer || (metron.observer = {}));
    var guid;
    (function (guid) {
        function generateGUIDPart() {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }
        function newGuid() {
            return (generateGUIDPart() + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + "-" + generateGUIDPart() + generateGUIDPart() + generateGUIDPart());
        }
        guid.newGuid = newGuid;
    })(guid = metron.guid || (metron.guid = {}));
})(metron || (metron = {}));
if (typeof (document) !== 'undefined' && typeof (document.location) !== 'undefined') {
    if (typeof (document.location.querystring) === 'undefined') {
        document.location.querystring = metron.web.querystring;
    }
    if (typeof (document.location.headers) === 'undefined') {
        document.location.headers = metron.web.headers;
    }
}
var metron;
(function (metron) {
    var controls;
    (function (controls) {
        function polyfill() {
            function fillDateInput(currentDate, keyCode) {
                var currentLength = currentDate.length;
                var lastCharEntered = currentDate[currentLength - 1];
                var daysInMonth = ["0", "31", "28", "31", "30", "31", "30", "31", "31", "30", "31", "30", "31"];
                var currentMonth = currentLength > 2 ? Number(currentDate.substring(0, 2)) : 0;
                if (currentLength == 2 && currentDate[0] == "1" && lastCharEntered == "/")
                    return "01/";
                if (!isNumber(lastCharEntered)) {
                    return currentDate.substring(0, currentLength - 1);
                }
                if (currentLength > 10) {
                    return currentDate.substring(0, 10);
                }
                if (currentLength == 1 && Number(currentDate) > 1) {
                    return "0" + currentDate + '/';
                }
                else if (currentLength == 3) {
                    if (Number(lastCharEntered) > 3) {
                        return currentDate.substring(0, 2) + "/0" + lastCharEntered + '/';
                    }
                    else {
                        return currentDate.substring(0, 2) + "/" + lastCharEntered;
                    }
                }
                else if (currentLength == 4 && Number(currentDate[3]) > 3) {
                    return currentDate.substring(0, 3) + "0" + currentDate[3] + '/';
                }
                else if (currentLength == 4 && Number(currentDate[3]) == 3 && currentMonth == 2) {
                    return currentDate.substring(0, 3) + "0" + currentDate[3] + '/';
                }
                else if (currentLength == 4 && Number(currentDate[3]) == 3 && currentMonth != 0) {
                    if (keyCode != 8) {
                        if (daysInMonth[currentMonth] == "30") {
                            return currentDate.substring(0, 3) + daysInMonth[currentMonth] + '/';
                        }
                        else {
                            return currentDate;
                        }
                    }
                    else {
                        return currentDate.substring(0, 3);
                    }
                }
                else if (currentLength == 2) {
                    if (keyCode != 8) {
                        if (Number(lastCharEntered) > 2 && currentDate[0] == "1") {
                            return currentDate.substring(0, currentLength - 1);
                        }
                        else {
                            return currentDate + '/';
                        }
                    }
                }
                else if (currentLength == 5) {
                    if (keyCode != 8) {
                        if (Number(currentDate[3]) == 3 && Number(lastCharEntered) > 1) {
                            return currentDate.substring(0, currentLength - 1);
                        }
                        else {
                            return currentDate + '/';
                        }
                    }
                }
                else if (currentLength == 6) {
                    return currentDate.substring(0, 5) + "/" + lastCharEntered;
                }
                else if (currentLength == 10 && Number(currentDate[3]) == 2 && Number(currentDate[4]) == 9 && currentMonth == 2) {
                    if (!isLeapYear(currentDate.substring(6))) {
                        return currentDate.replace("29", "28");
                    }
                }
                return currentDate;
            }
            function fillTimeInput(currentTime, keyCode) {
                var currentLength = currentTime.length;
                var lastCharEntered = currentTime[currentLength - 1];
                if (currentLength < 6 && !isNumber(lastCharEntered)) {
                    return currentTime.substring(0, currentLength - 1);
                }
                if ((currentLength == 6 || currentLength == 7) && !(lastCharEntered.toLowerCase() == "a" || lastCharEntered.toLowerCase() == "p")) {
                    return currentTime.substring(0, currentLength - 1);
                }
                if (currentLength > 8) {
                    return currentTime.substring(0, 8);
                }
                if (currentLength == 1 && Number(currentTime) > 1) {
                    return "0" + currentTime + ':';
                }
                else if (currentLength == 3) {
                    if (Number(lastCharEntered) > 5) {
                        return currentTime.substring(0, 2) + ":0" + lastCharEntered + ' ';
                    }
                    else {
                        return currentTime.substring(0, 2) + ":" + lastCharEntered;
                    }
                }
                else if (currentLength == 4 && Number(currentTime[3]) > 5) {
                    return currentTime.substring(0, 3) + "0" + currentTime[3] + ' ';
                }
                else if (currentLength == 2) {
                    if (keyCode != 8) {
                        return currentTime + ':';
                    }
                }
                else if (currentLength == 5) {
                    if (keyCode != 8) {
                        return currentTime + ' ';
                    }
                }
                else if (currentLength == 6) {
                    if (lastCharEntered.toLowerCase() == "a")
                        return currentTime.substring(0, 5) + " AM";
                    if (lastCharEntered.toLowerCase() == "p")
                        return currentTime.substring(0, 5) + " PM";
                }
                else if (currentLength == 6 || currentLength == 7) {
                    if (keyCode == 8) {
                        return currentTime.substring(0, currentLength - 1);
                    }
                    else {
                        if (lastCharEntered.toLowerCase() == "a")
                            return currentTime.substring(0, 5) + " AM";
                        if (lastCharEntered.toLowerCase() == "p")
                            return currentTime.substring(0, 5) + " PM";
                    }
                }
                return currentTime;
            }
            function isNumber(n) {
                return !isNaN(parseFloat(n)) && isFinite(n);
            }
            function isLeapYear(year) {
                return ((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0);
            }
            function checkDateInputSupport() {
                var input = document.createElement("input");
                input.setAttribute("type", "date");
                var notADateValue = "not-a-date";
                input.setAttribute("value", notADateValue);
                return !(input.value === notADateValue);
            }
            if (!checkDateInputSupport() && typeof window.orientation === 'undefined') {
                metron.globals.requiresDateTimePolyfill = true;
                document.selectAll("input[type=date]").each(function (idx, elem) {
                    elem.placeholder = "mm/dd/yyyy";
                    elem.addEventListener("keyup", function (e) {
                        elem.val(fillDateInput(elem.val(), e.keyCode));
                    });
                });
                document.selectAll("input[type=time]").each(function (idx, elem) {
                    elem.placeholder = "--:-- --";
                    elem.addEventListener("keyup", function (e) {
                        elem.value = fillTimeInput(elem.val(), e.keyCode);
                    });
                });
            }
        }
        controls.polyfill = polyfill;
        function getPivot(name, callback) {
            var p;
            if (metron.globals["pivots"][name] != null) {
                p = metron.globals["pivots"][name];
            }
            else {
                p = new metron.controls.pivot(document.selectOne("[data-m-type='pivot'][data-m-page='" + name + "']"));
                metron.globals["pivots"][name] = p;
            }
            if (callback != null) {
                callback(p);
            }
            return p;
        }
        controls.getPivot = getPivot;
        var pivots = (function () {
            function pivots() {
            }
            pivots.bindAll = function (callback) {
                var pivots = document.selectAll("[data-m-type='pivot']");
                var _loop_1 = function (i) {
                    var section = pivots[i];
                    var page = section.attribute("data-m-page");
                    if (metron.globals["pivots"][page] == null) {
                        var p_1 = new controls.pivot(section);
                        metron.globals["pivots"][page] = p_1;
                        section.selectAll("[data-m-pivot]").each(function (idx, elem) {
                            if (elem.up("[data-m-type='pivot']").attribute("data-m-page") == null || elem.up("[data-m-type='pivot']").attribute("data-m-page") === page) {
                                elem.addEvent("click", function (e) {
                                    e.preventDefault();
                                    var p1 = metron.globals["pivots"][page];
                                    p_1.exact(elem.attribute("data-m-pivot"));
                                }, true);
                            }
                        });
                    }
                };
                for (var i = 0; i < pivots.length; i++) {
                    _loop_1(i);
                }
                if (callback != null) {
                    callback();
                }
            };
            return pivots;
        }());
        controls.pivots = pivots;
        var pivot = (function () {
            function pivot(pivotCollection, displayIndex, nextButton, previousButton) {
                if (displayIndex === void 0) { displayIndex = 0; }
                this.pivotCollection = pivotCollection;
                this.displayIndex = displayIndex;
                this.nextButton = nextButton;
                this.previousButton = previousButton;
                this._items = [];
                this._preEventFunctions = {};
                this._postEventFunctions = {};
                var self = this;
                self._name = pivotCollection.attribute("data-m-page");
                self._pivotContainer = pivotCollection;
                self._nextButton = (nextButton != null) ? document.selectOne("#" + nextButton) : self._pivotContainer.selectOne("[data-m-segment='controls'] [data-m-action='next']");
                self._previousButton = (previousButton != null) ? document.selectOne("#" + previousButton) : self._pivotContainer.selectOne("[data-m-segment='controls'] [data-m-action='previous']");
                if (self.displayIndex != null) {
                    var i = 0;
                    var itemList = self._pivotContainer.selectAll("[data-m-segment='pivot-item']");
                    itemList.each(function (idx, elem) {
                        if (elem.up("[data-m-type='pivot']").attribute("data-m-page") == null || elem.up("[data-m-type='pivot']").attribute("data-m-page") === self._name) {
                            self._items.push(elem);
                            if (idx == self.displayIndex) {
                                self.init(elem);
                                elem.show();
                            }
                            else {
                                elem.hide();
                            }
                        }
                    });
                }
            }
            pivot.prototype.init = function (el) {
                var self = this;
                self._item = {
                    parent: el.parentElement,
                    current: el,
                    next: (el.nextElementSibling != null && el.nextElementSibling.attribute("data-m-segment") != null && el.nextElementSibling.attribute("data-m-segment") == "pivot-item") ? el.nextElementSibling : null,
                    previous: (el.previousElementSibling != null && el.previousElementSibling.attribute("data-m-segment") != null && el.previousElementSibling.attribute("data-m-segment") == "pivot-item") ? el.previousElementSibling : null,
                };
                if (self._nextButton != null || self._previousButton != null) {
                    if (self._item.next == null) {
                        self._nextButton.attribute("disabled", "disabled");
                    }
                    else {
                        self._nextButton.removeAttribute("disabled");
                        self._nextButton.addEvent("click", function (e) {
                            e.preventDefault();
                            self.next();
                        }, true);
                    }
                    if (self._item.previous == null) {
                        self._previousButton.attribute("disabled", "disabled");
                    }
                    else {
                        self._previousButton.removeAttribute("disabled");
                        self._previousButton.addEvent("click", function (e) {
                            e.preventDefault();
                            self.previous();
                        }, true);
                    }
                }
                if (self._item.current.attribute('data-m-page') != null) {
                    if (self._postEventFunctions[self._item.current.attribute('data-m-page')] != undefined) {
                        self._postEventFunctions[self._item.current.attribute('data-m-page')]();
                    }
                }
            };
            pivot.prototype.applyPreEvent = function (el) {
                var self = this;
                if (el.attribute('data-m-page') != null) {
                    if (self._preEventFunctions[el.attribute('data-m-page')] != undefined) {
                        self._preEventFunctions[el.attribute('data-m-page')]();
                    }
                }
            };
            pivot.prototype.addPreEvent = function (name, func) {
                var self = this;
                if (self._preEventFunctions[name] == undefined) {
                    self._preEventFunctions[name] = func;
                }
                else {
                    console.log(name + " pre-event function already exists.");
                }
            };
            pivot.prototype.addPostEvent = function (name, func) {
                var self = this;
                if (self._postEventFunctions[name] == undefined) {
                    self._postEventFunctions[name] = func;
                }
                else {
                    console.log(name + " pre-event function already exists.");
                }
            };
            pivot.prototype.removePostEvent = function (name) {
                delete this._postEventFunctions[name];
            };
            pivot.prototype.removePreEvent = function (name) {
                delete this._preEventFunctions[name];
            };
            pivot.prototype.next = function () {
                var self = this;
                if (!self._item.next) {
                    console.log("Couldn't find next pivot. Using last pivot instead.");
                    self._item.next = self._items[self._items.length - 1];
                }
                self.applyPreEvent(self._item.current);
                for (var i = 0; i < self._items.length; i++) {
                    self._items[i].hide();
                }
                self._item.next.show();
                self.init(self._item.next);
            };
            pivot.prototype.previous = function () {
                var self = this;
                if (!self._item.previous) {
                    console.log("Couldn't find previous pivot. Using first pivot instead.");
                    self._item.previous = self._items[0];
                }
                self.applyPreEvent(self._item.current);
                for (var i = 0; i < self._items.length; i++) {
                    self._items[i].hide();
                }
                self._item.previous.show();
                self.init(self._item.previous);
            };
            pivot.prototype.exact = function (target) {
                var self = this;
                var idx;
                if (isNaN(target)) {
                    for (var i = 0; i < self._items.length; i++) {
                        var page = self._items[i].attribute("data-m-page");
                        if (page != null && page == target) {
                            idx = i;
                        }
                    }
                    if (idx == null) {
                        throw new Error("Error: Cannot find a pivot with page name " + target);
                    }
                }
                else {
                    idx = target;
                }
                if (!self._items[idx]) {
                    console.log("Error: No pivot at index " + idx);
                    return false;
                }
                self.applyPreEvent(self._item.current);
                for (var i = 0; i < self._items.length; i++) {
                    self._items[i].hide();
                }
                self._items[idx].show();
                if (self._items[idx].attribute("data-m-page") != null) {
                    metron.routing.setRouteUrl(self._items[idx].attribute("data-m-page"), "", true);
                }
                self.init(self._items[idx]);
                return true;
            };
            return pivot;
        }());
        controls.pivot = pivot;
    })(controls = metron.controls || (metron.controls = {}));
})(metron || (metron = {}));
var metron;
(function (metron) {
    var store = (function () {
        function store(localDBName, localDBVersion, localDBStore) {
            this.localDBName = localDBName;
            this.localDBVersion = localDBVersion;
            this.localDBStore = localDBStore;
            this._hasIndexedDB = false;
            var self = this;
            if (localDBName == null) {
                self.localDBName = metron.config["config.storage.localDBName"];
            }
            if (localDBVersion == null) {
                self.localDBVersion = metron.config["config.storage.localDBVersion"];
            }
            if (localDBStore == null) {
                self.localDBStore = metron.config["config.storage.localDBStore"];
            }
        }
        store.prototype.init = function () {
            var self = this;
            var p = new RSVP.Promise(function (resolve, reject) {
                try {
                    window.indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
                    window.IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.msIDBTransaction || { READ_WRITE: "readwrite" };
                    window.IDBKeyRange = window.IDBKeyRange || window.webkitIDBKeyRange || window.msIDBKeyRange;
                    if (!window.indexedDB) {
                        console.log("Warning: IndexedDB is unavailable. Using localStorage instead.");
                    }
                    else {
                        self._hasIndexedDB = true;
                        var request = window.indexedDB.open(self.localDBName, self.localDBVersion);
                        request.onerror = function (evt) {
                            self._hasIndexedDB = false;
                            console.log("Warning: Access to IndexedDB for application has been rejected.");
                        };
                        request.onupgradeneeded = function (evt) {
                            var objectStore = evt.currentTarget.result.createObjectStore(self.localDBStore, { keyPath: "name" });
                            objectStore.createIndex("name", "name", { unique: true });
                            objectStore.transaction.oncomplete = function (oevt) {
                                console.log("Info: Object store has been successfully created. " + objectStore);
                            };
                        };
                        request.onsuccess = function (evt) {
                            self._db = evt.target.result;
                            console.log("Info: Database initialized. " + self._db);
                            resolve(self._db);
                        };
                    }
                }
                catch (e) {
                    console.log("Error: Failed to initialize storage. " + e);
                    reject(e);
                }
            });
            return p;
        };
        store.prototype.getObjectStore = function () {
            var self = this;
            try {
                var transaction = self._db.transaction(self.localDBStore, "readwrite");
                return transaction.objectStore(self.localDBStore);
            }
            catch (e) {
                console.log("Error: Failed to get object store. " + e);
                return null;
            }
        };
        store.prototype.getItem = function (s, val) {
            var self = this;
            var p = new RSVP.Promise(function (resolve, reject) {
                try {
                    if (window.indexedDB != null) {
                        var objectStore = self.getObjectStore();
                        var request = objectStore.get(s);
                        request.onsuccess = function (evt) {
                            if (val != null && evt.target.result != null) {
                                resolve(evt.target.result[val]);
                            }
                            else {
                                resolve(evt.target.result);
                            }
                        };
                    }
                    else if (sessionStorage != null) {
                        resolve(sessionStorage.getItem(s));
                    }
                }
                catch (e) {
                    console.log("Error: Failed to retrieve item. " + e);
                    reject(e);
                }
            });
            return p;
        };
        store.prototype.setItem = function (s, a) {
            var self = this;
            var p = new RSVP.Promise(function (resolve, reject) {
                try {
                    if (window.indexedDB != null) {
                        var objectStore = self.getObjectStore();
                        if (!(typeof a === "string")) {
                            var b = {};
                            for (var prop in a) {
                                if (a.hasOwnProperty(prop) && (!(a[prop] instanceof Function))) {
                                    b[prop] = a[prop];
                                }
                            }
                            delete b["__proto__"];
                            a = JSON.stringify(b);
                        }
                        var item = { "name": s, "value": a };
                        var request = objectStore.put(item);
                        request.onsuccess = function (evt) {
                            console.log("Info: Item added to the object store. " + evt.target.result);
                            resolve(evt.target.result);
                        };
                    }
                    else if (sessionStorage != null) {
                        sessionStorage.setItem(s, a);
                        resolve(true);
                    }
                }
                catch (e) {
                    console.log("Error: Failed to set item. " + e);
                    reject(e);
                }
            });
            return p;
        };
        store.prototype.removeItem = function (s) {
            var self = this;
            var p = new RSVP.Promise(function (resolve, reject) {
                try {
                    if (window.indexedDB != null) {
                        var request = self.getObjectStore().delete(s);
                        request.onsuccess = function (evt) {
                            console.log("Info: Object deleted.");
                            resolve(true);
                        };
                    }
                    else if (sessionStorage != null) {
                        sessionStorage.removeItem(s);
                        resolve(true);
                    }
                }
                catch (e) {
                    console.log("Error: Failed to remove item. " + e);
                    reject(e);
                }
            });
            return p;
        };
        store.prototype.clearItems = function () {
            var self = this;
            try {
                if (window.indexedDB != null) {
                    self.getObjectStore().clear();
                }
                if (sessionStorage != null) {
                    sessionStorage.clear();
                    return true;
                }
            }
            catch (e) {
                console.log("Error: Failed to clear items. " + e);
                return false;
            }
            return false;
        };
        return store;
    }());
    metron.store = store;
})(metron || (metron = {}));
var metron;
(function (metron) {
    var tools;
    (function (tools) {
        function reduceObject(key, obj) {
            var resp = [];
            obj.forEach(function (val, idx) {
                for (var k in val) {
                    if (k === key) {
                        resp.push(val[k]);
                    }
                }
            });
            return resp;
        }
        tools.reduceObject = reduceObject;
        function normalizeModelItems(obj, model, first) {
            if (first === void 0) { first = false; }
            var result = obj;
            if (!first) {
                if (obj[model] != null) {
                    result = obj[model];
                }
            }
            else {
                if (obj[model] != null) {
                    result = obj[model][0];
                }
            }
            return result;
        }
        tools.normalizeModelItems = normalizeModelItems;
        function normalizeModelData(obj) {
            for (var k in obj) {
                if (obj[k] == null || obj[k] === "null") {
                    delete obj[k];
                }
            }
            return obj;
        }
        tools.normalizeModelData = normalizeModelData;
        function formatOptions(attr, opt) {
            if (opt === void 0) { opt = metron.OptionTypes.KEYVALUE; }
            var pairDivider;
            var optDivider;
            switch (opt) {
                case metron.OptionTypes.QUERYSTRING:
                    pairDivider = "&";
                    optDivider = "=";
                    break;
                default:
                    pairDivider = ";";
                    optDivider = ":";
                    break;
            }
            var pairs = attr.split(pairDivider);
            if (pairs[pairs.length - 1].trim() == "") {
                pairs.pop();
            }
            var result = "";
            for (var i = 0; i < pairs.length; i++) {
                var p = pairs[i].split(optDivider);
                try {
                    result += "\"" + p[0].trim() + "\":\"" + p[1].trim() + "\"";
                    if (i != (pairs.length - 1)) {
                        result += ",";
                    }
                }
                catch (e) {
                    throw new Error("Error: Invalid key/value pair!");
                }
            }
            var response = null;
            try {
                response = JSON.parse("{" + result + "}");
            }
            catch (e) {
                throw new Error("Error: Invalid JSON for options!");
            }
            return response;
        }
        tools.formatOptions = formatOptions;
        function cleanURL(url) {
            if (url.startsWith("//")) {
                url = url.substring(1);
            }
            if (url.endsWith("?")) {
                url = url.substring(0, url.length - 1);
            }
            if (url == "/") {
                return "";
            }
            return url;
        }
        tools.cleanURL = cleanURL;
        function normalizeURL(url) {
            if (url.endsWith("/")) {
                return url.substr(0, (url.length - 2));
            }
            return url;
        }
        tools.normalizeURL = normalizeURL;
        function loadJSON(url, callback) {
            if (!url.contains("://")) {
                url = window.location.protocol + "//" + normalizeURL(window.location.host) + "/" + url;
            }
            metron.web.get("" + url, {}, null, "JSON", function (data) {
                if (callback != null) {
                    callback(data);
                }
            });
        }
        tools.loadJSON = loadJSON;
        function getMatching(text, regex) {
            var match = regex.exec(text);
            if (match[1] !== undefined) {
                if (match[1].contains("\"")) {
                    return match[1].split("\"")[0];
                }
                return match[1];
            }
            return null;
        }
        tools.getMatching = getMatching;
        function getDataPrimary(key, values) {
            return values.getValueByKey(key);
        }
        tools.getDataPrimary = getDataPrimary;
        function formatMessage(message, length) {
            try {
                var len = (length != null && length > 0) ? length : 15;
                if (message.split(" ").length > len) {
                    return message.truncateWords(len) + "...";
                }
            }
            catch (e) {
            }
            return message;
        }
        tools.formatMessage = formatMessage;
        function eventEnumToString(e) {
            switch (e) {
                case metron.Event.INIT:
                    return "init";
                case metron.Event.LOAD_FILTERS:
                    return "loadFilters";
                case metron.Event.APPLY_VIEW_EVENTS:
                    return "applyViewEvents";
                case metron.Event.POPULATE_LISTING:
                    return "populateListing";
                case metron.Event.UNDO_LAST:
                    return "undoLast";
                case metron.Event.CALL_LISTING:
                    return "callListing";
                case metron.Event.SAVE:
                    return "save";
                case metron.Event.LOAD_FORM:
                    return "loadForm";
                case metron.Event.LOAD_SELECTS:
                    return "loadSelects";
                case metron.Event.CLEAR_FORM:
                    return "clearForm";
                case metron.Event.NEW:
                    return "new";
                case metron.Event.UNDO:
                    return "undo";
                case metron.Event.DOWNLOAD:
                    return "download";
                case metron.Event.EDIT:
                    return "edit";
                case metron.Event.DELETE:
                    return "delete";
                case metron.Event.CANCEL:
                    return "cancel";
                default:
                    throw new Error("Error: Invalid enum.");
            }
        }
        tools.eventEnumToString = eventEnumToString;
        function formatDecimal(num) {
            var dec = parseFloat(num.toString());
            return dec.toFixed(2);
        }
        tools.formatDecimal = formatDecimal;
        function formatDate(datetime) {
            if (!String.isNullOrEmpty(datetime)) {
                var d = convertDateStringToDate(datetime);
                var m = d.getMonth() + 1;
                var mm = m < 10 ? "0" + m : m;
                var dd = d.getDate();
                var ddd = dd < 10 ? "0" + dd : dd;
                var y = d.getFullYear();
                return mm + "-" + ddd + "-" + y;
            }
            return "";
        }
        tools.formatDate = formatDate;
        function formatDateTime(datetime) {
            if (!String.isNullOrEmpty(datetime)) {
                var d = convertDateStringToDate(datetime);
                var m = d.getMonth() + 1;
                var mm = m < 10 ? "0" + m : m;
                var dd = d.getDate();
                var ddd = dd < 10 ? "0" + dd : dd;
                var y = d.getFullYear();
                var time = formatTime(d, true);
                return mm + "-" + ddd + "-" + y + " " + time;
            }
            return "";
        }
        tools.formatDateTime = formatDateTime;
        function formatTime(datetime, isFullDate) {
            if (isFullDate === void 0) { isFullDate = false; }
            var d;
            if (isFullDate) {
                if (datetime.length) {
                    d = convertDateStringToDate(datetime);
                }
                else {
                    d = datetime;
                }
            }
            else {
                var c = datetime.split(":");
                d = new Date(new Date().getFullYear(), new Date().getMonth(), new Date().getDate(), parseInt(c[0], 10), parseInt(c[1], 10), parseInt(c[2], 10));
            }
            var h = d.getHours();
            var m = d.getMinutes();
            var ampm = h >= 12 ? "pm" : "am";
            h = h % 12;
            h = h ? h : 12;
            var mm = m < 10 ? "0" + m : m;
            var result = h + ":" + mm + " " + ampm;
            return result;
        }
        tools.formatTime = formatTime;
        function formatBoolean(b) {
            if (b.toBool()) {
                return "yes";
            }
            return "no";
        }
        tools.formatBoolean = formatBoolean;
        function convertDateStringToDate(datetime) {
            if (datetime.indexOf("T") > 0 && datetime.indexOf("-") > 0 && datetime.toLowerCase().indexOf("gmt") == -1) {
                var dateString = datetime.substring(0, datetime.indexOf("T"));
                var dateArray = dateString.split("-");
                var timeString = datetime.substring(datetime.indexOf("T") + 1, datetime.length);
                var timeArray = timeString.split(":");
                return new Date(parseInt(dateArray[0]), parseInt(dateArray[1]) - 1, parseInt(dateArray[2]), parseInt(timeArray[0], 10), parseInt(timeArray[1], 10), parseInt(timeArray[2], 10), 0);
            }
            else if (datetime.indexOf(" ") > 0 && datetime.indexOf("/") > 0) {
                var dateString = datetime.substring(0, datetime.indexOf(" "));
                var dateArray = dateString.split("/");
                var timeString = datetime.substring(datetime.indexOf(" ") + 1, datetime.length);
                var timeArray = timeString.split(":");
                return new Date(parseInt(dateArray[2]), parseInt(dateArray[0]) - 1, parseInt(dateArray[1]), parseInt(timeArray[0], 10), parseInt(timeArray[1], 10), parseInt(timeArray[2], 10), 0);
            }
            return new Date(datetime);
        }
        tools.convertDateStringToDate = convertDateStringToDate;
    })(tools = metron.tools || (metron.tools = {}));
})(metron || (metron = {}));
var metron;
(function (metron) {
    var base = (function () {
        function base(model, baseType) {
            this.model = model;
            this.baseType = baseType;
        }
        base.prototype.attachPivot = function (elem) {
            if (elem.up("[data-m-type='pivot']")) {
                var pivotName = elem.up("[data-m-type='pivot']").attribute("data-m-page");
                return metron.controls.getPivot(pivotName);
            }
            return undefined;
        };
        base.prototype.inject = function (type, method, func) {
            var self = this;
            if (func == null) {
                throw new Error("Error: No function passed for injection!");
            }
            switch (type.lower()) {
                case "append":
                    self[method + "_m_inject"] = func;
                    break;
                case "overwrite":
                    self[method] = func;
                    break;
                default:
                    throw new Error("Error: Invalid injection type!");
            }
            return self;
        };
        base.prototype.on = function (method, func, overwrite) {
            if (overwrite === void 0) { overwrite = false; }
            var self = this;
            self.inject((overwrite) ? "overwrite" : "append", metron.tools.eventEnumToString(method), func);
            return self;
        };
        base.prototype.action = function (action, model, func) {
            var self = this;
            component.action(action, model, func);
            return self;
        };
        base.prototype.clearAlerts = function () {
            var self = this;
            var elem = document.selectOne("[data-m-type='" + self.baseType + "'][data-m-model='" + self.model + "'] [data-m-segment='alert']");
            elem.innerHTML = "";
            elem.removeClass("info").removeClass("warning").removeClass("danger").removeClass("success");
            elem.attribute("data-m-state", "hide");
            elem.hide();
        };
        base.prototype.showAlerts = function (className, txt, jsn, xml) {
            var self = this;
            var elem = document.selectOne("[data-m-type='" + self.baseType + "'][data-m-model='" + self.model + "'] [data-m-segment='alert']");
            elem.innerHTML = txt;
            elem.addClass(className);
            elem.attribute("data-m-state", "show");
            elem.show();
        };
        base.prototype.shouldRoute = function (options) {
            if (options == null || options.hasRouting == null || options.hasRouting) {
                return true;
            }
            return false;
        };
        return base;
    }());
    metron.base = base;
    var component = (function (_super) {
        __extends(component, _super);
        function component() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        component.action = function (action, prefix, func) {
            metron.globals.actions[prefix + "_" + action] = func;
        };
        return component;
    }(base));
    metron.component = component;
})(metron || (metron = {}));
var metron;
(function (metron) {
    var routing;
    (function (routing) {
        function setRouteUrl(name, wsqs, wantsReplaceHash) {
            if (wantsReplaceHash === void 0) { wantsReplaceHash = false; }
            var hash = (wsqs.length > 1) ? wsqs.substr(1) : "";
            if (hash != "" && document.location.search != null) {
                try {
                    var hashItems = metron.tools.formatOptions(hash, metron.OptionTypes.QUERYSTRING);
                    var qsItems = metron.tools.formatOptions((document.location.search.startsWith("?") ? document.location.search.substr(1) : document.location.search), metron.OptionTypes.QUERYSTRING);
                    for (var h in hashItems) {
                        if (hashItems.hasOwnProperty(h)) {
                            if (qsItems[h] != null) {
                                delete hashItems[h];
                            }
                        }
                    }
                    hash = metron.web.querystringify(hashItems).substr(1);
                }
                catch (e) {
                    console.log("Error: failed to parse query string and hash. " + e);
                }
            }
            if (name != null) {
                hash = "/" + name + "/" + hash;
            }
            metron.globals.hashLoadedFromApplication = true;
            if (hash != null && hash != "") {
                (wantsReplaceHash) ? document.location.hash = "#" + hash : history.replaceState({}, "", "#" + hash);
            }
        }
        routing.setRouteUrl = setRouteUrl;
        function getRouteUrl(filters) {
            var hash = document.location.hash;
            if (hash.substr(0, 1) == "#") {
                hash = hash.substr(1);
            }
            if (hash.substr(0, 1) == "/") {
                hash = hash.substr(1);
            }
            if (hash.length > 1) {
                if (hash.indexOf("/") != -1) {
                    try {
                        hash = hash.split("/")[1];
                    }
                    catch (e) {
                        console.log("Error: Failed to get routing. " + e);
                    }
                }
                var result = metron.tools.formatOptions(hash, metron.OptionTypes.QUERYSTRING);
                if (filters != null) {
                    for (var h in result) {
                        if (result.hasOwnProperty(h)) {
                            if (filters[h] != null) {
                                delete result[h];
                            }
                        }
                    }
                }
                return result;
            }
            return null;
        }
        routing.getRouteUrl = getRouteUrl;
        function getRouteName() {
            var hash = document.location.hash;
            if (hash.substr(0, 1) == "#") {
                hash = hash.substr(1);
            }
            if (hash.substr(0, 1) == "/") {
                hash = hash.substr(1);
            }
            if (hash.length > 1) {
                if (hash.indexOf("/") != -1) {
                    try {
                        hash = hash.split("/")[0];
                    }
                    catch (e) {
                        console.log("Error: Failed to get routing. " + e);
                        return null;
                    }
                }
                return hash;
            }
            return null;
        }
        routing.getRouteName = getRouteName;
    })(routing = metron.routing || (metron.routing = {}));
})(metron || (metron = {}));
var metron;
(function (metron) {
    metron.config = {};
    metron.globals = {
        actions: {},
        forms: {},
        lists: {},
        pivots: {},
        handlers: {},
        hashLoadedFromApplication: false,
        firstLoad: false,
        requiresDateTimePolyfill: false
    };
    function onready(callback, appName) {
        document.addEventListener("DOMContentLoaded", function (e) {
            metron.templates.master.loadMaster(document.documentElement.outerHTML).then(function () {
                var proms = [];
                document.selectAll("[data-m-include]").each(function (idx, elem) {
                    var prom = metron.templates.load(elem.attribute("data-m-include")).then(function (result) {
                        if (elem.attribute("data-m-type") != null && elem.attribute("data-m-type") == "markdown") {
                            elem.innerHTML = metron.templates.markdown.toHTML(result);
                            elem.show();
                        }
                        else {
                            elem.innerHTML = result;
                        }
                    });
                    proms.push(prom);
                });
                RSVP.all(proms).then(function () {
                    document.selectAll("[data-m-type='markdown']").each(function (idx, elem) {
                        if (elem.attribute("data-m-include") == null) {
                            elem.innerHTML = metron.templates.markdown.toHTML(elem.innerHTML);
                            elem.show();
                        }
                    });
                    var root = metron.fw.getApplicationRoot(document.documentElement.outerHTML);
                    appName = (appName != null) ? appName : metron.fw.getApplicationName(document.documentElement.outerHTML);
                    var iDB = (appName == null) ? metron.DB : metron.DB + "." + appName.lower();
                    var iDBStore = (appName == null) ? metron.STORE : metron.STORE + "." + appName.lower();
                    var store = new metron.store(iDB, metron.DBVERSION, iDBStore);
                    store.init().then(function (result) {
                        return store.getItem("metron.config", "value");
                    }).then(function (result) {
                        if (result != null) {
                            metron.config = JSON.parse(result);
                            metron.globals.firstLoad = true;
                            if (callback != null) {
                                callback(e);
                            }
                        }
                        else {
                            new RSVP.Promise(function (resolve, reject) {
                                metron.tools.loadJSON(root + "/metron.json", function (configData) {
                                    for (var obj in configData) {
                                        if (metron.config[obj] == null) {
                                            metron.config[obj] = configData[obj];
                                        }
                                    }
                                    metron.config["config.baseURL"] = document.location.protocol + "//" + document.location.host;
                                    store.init().then(function (result) {
                                        return store.setItem("metron.config", JSON.stringify(metron.config));
                                    }).then(function (result) {
                                        resolve(configData);
                                    }).catch(function (rs) {
                                        console.log("Error: Failed to access storage. " + rs);
                                    });
                                });
                            }).then(function () {
                                metron.globals.firstLoad = true;
                                if (callback != null) {
                                    callback(e);
                                }
                            }).catch(function (rsn) {
                                console.log("Error: Promise execution failed! " + rsn);
                            });
                        }
                    }).catch(function (reason) {
                        console.log("Error: Failed to access storage. " + reason);
                    });
                });
            }).catch(function () {
                console.log("Failed to check for master page.");
            });
        });
    }
    metron.onready = onready;
    function load(segment, model, func, name) {
        if (name == null) {
            if (document.selectOne("[data-m-type=\"" + segment + "\"][data-m-model=\"" + model + "\"]") != null) {
                func();
            }
        }
        else {
            if (document.selectOne("[data-m-type=\"" + segment + "\"][data-m-model=\"" + model + "\"][data-m-page=\"" + name + "\"]") != null) {
                func();
            }
        }
    }
    metron.load = load;
    function ifQuerystring(callback) {
        var qs = metron.web.querystring();
        if (qs != "") {
            var parameters = metron.tools.formatOptions(qs, metron.OptionTypes.QUERYSTRING);
            if (callback != null) {
                callback(parameters);
            }
        }
    }
    metron.ifQuerystring = ifQuerystring;
    var fw;
    (function (fw) {
        function getApplicationRoot(page) {
            var root = (document.selectOne("body[data-m-root]") != null) ? "" + document.selectOne("body[data-m-root]").attribute("data-m-root") : null;
            if (root == null) {
                root = metron.tools.getMatching(page, /\{\{m:root=\"(.*)\"\}\}/g);
            }
            metron.config["config.root"] = (root != null) ? root : "";
            return root;
        }
        fw.getApplicationRoot = getApplicationRoot;
        function getApplicationName(page) {
            var appName = (document.selectOne("body[data-m-page]") != null) ? "" + document.selectOne("body[data-m-page]").attribute("data-m-page") : null;
            if (appName == null) {
                appName = metron.tools.getMatching(page, /\{\{m:page=\"(.*)\"\}\}/g);
            }
            metron.config["config.appName"] = (appName != null) ? appName : "";
            return appName;
        }
        fw.getApplicationName = getApplicationName;
        function getBaseUrl() {
            if (metron.config["config.baseURL"] != null) {
                return (metron.config["config.baseURL"].endsWith("/")) ? metron.config["config.baseURL"].substr(0, metron.config["config.baseURL"].length - 2) : "" + metron.config["config.baseURL"];
            }
            return "";
        }
        fw.getBaseUrl = getBaseUrl;
        function getAppUrl() {
            if (metron.config["config.baseURL"] != null) {
                var url = (metron.config["config.baseURL"].endsWith("/")) ? metron.config["config.baseURL"].substr(0, metron.config["config.baseURL"].length - 2) : "" + metron.config["config.baseURL"];
                return (metron.config["config.root"] != null && metron.config["config.root"] != "") ? url + "/" + metron.config["config.root"] : url;
            }
            return "";
        }
        fw.getAppUrl = getAppUrl;
        function getBaseAPI() {
            if (metron.config["config.api.dir"] != null) {
                var url = (metron.config["config.api.dir"].endsWith("/")) ? metron.config["config.api.dir"].substr(0, metron.config["config.api.dir"].length - 2) : "" + metron.config["config.api.dir"];
                return (metron.config["config.root"] != null && metron.config["config.root"] != "") ? metron.config["config.root"] + "/" + url : url;
            }
            return "";
        }
        fw.getBaseAPI = getBaseAPI;
        function getAPIExtension() {
            if (metron.config["config.api.extension"] != null) {
                return metron.config["config.api.extension"];
            }
            return "";
        }
        fw.getAPIExtension = getAPIExtension;
        function getAPIURL(model) {
            return metron.fw.getBaseUrl() + "/" + metron.fw.getBaseAPI() + "/" + model + metron.fw.getAPIExtension();
        }
        fw.getAPIURL = getAPIURL;
        function loadOptionalFunctionality() {
            if (typeof Awesomplete !== undefined) {
                if (metron.globals.autolists == null) {
                    metron.globals.autolists = {};
                }
                document.selectAll("[data-m-autocomplete]").each(function (idx, elem) {
                    var datalist = [];
                    var endpoint = elem.attribute("data-m-autocomplete");
                    var url = (endpoint.toLowerCase().startsWith("http")) ? endpoint : metron.fw.getAPIURL(endpoint);
                    metron.web.get("" + url + metron.web.querystringify({ IsActive: true, _SortOrder: elem.attribute("data-m-search-text"), _SortDirection: "ASC" }), null, null, "json", function (result) {
                        if (result != null) {
                            for (var a in result) {
                                if (result.hasOwnProperty(a)) {
                                    if (result[a][elem.attribute("data-m-search-text")] != null) {
                                        datalist.push(result[a][elem.attribute("data-m-search-text")]);
                                        if (!metron.globals.autolists[elem.attribute("id")]) {
                                            metron.globals.autolists[elem.attribute("id")] = {};
                                        }
                                        if (!metron.globals.autolists[elem.attribute("id")][result[a][elem.attribute("data-m-search-text")]]) {
                                            metron.globals.autolists[elem.attribute("id")][result[a][elem.attribute("data-m-search-text")]] = {};
                                        }
                                        metron.globals.autolists[elem.attribute("id")][result[a][elem.attribute("data-m-search-text")]] = result[a][elem.attribute("data-m-val")];
                                    }
                                }
                            }
                        }
                        var auto = new Awesomplete(elem, { minChars: 0, list: datalist, sort: false, maxItems: 20 });
                    });
                });
            }
        }
        fw.loadOptionalFunctionality = loadOptionalFunctionality;
    })(fw = metron.fw || (metron.fw = {}));
    window.onhashchange = function () {
        if (!metron.globals.hashLoadedFromApplication) {
            var hasPivoted = false;
            var section = document.selectOne("[data-m-type='pivot']");
            if (section != null) {
                var page = section.attribute("data-m-page");
                if (page != null) {
                    var p = metron.controls.getPivot(page);
                    p.previous();
                    hasPivoted = true;
                }
            }
            if (!hasPivoted) {
                window.location.reload(false);
            }
        }
        metron.globals.hashLoadedFromApplication = false;
    };
    metron.onready(function (e) {
        function recursePivot(elem) {
            if (elem != null) {
                elem.show();
                var route_1 = elem.attribute("data-m-page");
                var pivot = elem.up("[data-m-type='pivot']");
                var pivotPageName_1 = pivot.attribute("data-m-page");
                elem.up("[data-m-type='pivot']").selectAll("[data-m-segment='pivot-item']").each(function (idx, el) {
                    if (el.up("[data-m-type='pivot']").attribute("data-m-page") === pivotPageName_1) {
                        if (el.attribute("data-m-page") != route_1) {
                            el.hide();
                        }
                    }
                });
                var parent_1 = elem.parent().up("[data-m-segment='pivot-item']");
                if (parent_1 != null) {
                    recursePivot(parent_1);
                }
            }
        }
        var wantsAutoload = ((document.selectOne("[data-m-autoload]") != null) && (document.selectOne("[data-m-autoload]").attribute("data-m-autoload") == "true"));
        document.selectAll("[data-m-state='hide']").each(function (idx, elem) {
            elem.hide();
        });
        metron.controls.pivots.bindAll(function () {
            var route = metron.routing.getRouteName();
            if (route != null) {
                var page = document.selectOne("[data-m-segment='pivot-item'][data-m-page=\"" + route + "\"]");
                recursePivot(page);
            }
            metron.fw.loadOptionalFunctionality();
            if (wantsAutoload) {
                metron.lists.bindAll(function () {
                    metron.forms.bindAll(function () {
                        metron.controls.polyfill();
                    });
                });
            }
        });
    });
})(metron || (metron = {}));
var metron;
(function (metron) {
    var lists = (function () {
        function lists() {
        }
        lists.bindAll = function (callback) {
            var sections = document.selectAll("[data-m-type='list']");
            for (var i = 0; i < sections.length; i++) {
                var section = sections[i];
                if (section.attribute("data-m-autoload") == null || section.attribute("data-m-autoload") == "true") {
                    var model = section.attribute("data-m-model");
                    var mID = section.attribute("id");
                    var gTypeName = (mID != null) ? mID + "_" + model : model;
                    if (metron.globals["lists"][gTypeName] == null) {
                        var l = new list(model);
                        l.id = mID;
                        l.gTypeName = gTypeName;
                        l.init();
                    }
                }
            }
            if (callback != null) {
                callback();
            }
        };
        return lists;
    }());
    metron.lists = lists;
    var list = (function (_super) {
        __extends(list, _super);
        function list(model, options) {
            var _this = _super.call(this, model, metron.LIST) || this;
            _this.model = model;
            _this.options = options;
            _this._filters = {};
            _this.recycleBin = [];
            _this.currentPageIndex = 1;
            _this.pageSize = (!isNaN(metron.config["config.options.pageSize"])) ? metron.config["config.options.pageSize"] : 10;
            _this.totalPageSize = 0;
            _this.totalCount = 0;
            _this.sortOrder = (metron.config["config.options.sortOrder"] != null) ? metron.config["config.options.sortOrder"] : "DateCreated";
            _this.sortDirection = (metron.config["config.options.sortDirection"] != null) ? metron.config["config.options.sortDirection"] : "DESC";
            _this._defaults = (metron.config["config.lists.defaults"] != null) ? metron.config["config.lists.defaults"] : {};
            var self = _this;
            self.id = (options != null) ? options.mID : null;
            self.gTypeName = (options != null && options.mID != null) ? options.mID + "_" + model : model;
            metron.globals["lists"][self.gTypeName] = self;
            self.setFilters();
            return _this;
        }
        list.prototype.init = function () {
            var self = this;
            self._elem = (self.id != null) ? document.selectOne("#" + self.id) : document.selectOne("[data-m-type='list'][data-m-model='" + self.model + "']");
            if (self._elem != null) {
                self.pivot = self.attachPivot(self._elem);
                self._name = self._elem.attribute("data-m-page");
                var filterBlocks = self._elem.selectAll("[data-m-segment='filters']");
                filterBlocks.each(function (idx, elem) {
                    var filters = elem.selectAll("[data-m-action='filter']");
                    self.loadFilters(filters);
                });
                var controlBlocks = self._elem.selectAll("[data-m-segment='controls']");
                controlBlocks.each(function (idx, elem) {
                    var actions = elem.selectAll("[data-m-action]");
                    actions.each(function (indx, el) {
                        switch (el.attribute("data-m-action").lower()) {
                            case "new":
                                el.addEvent("click", function (e) {
                                    e.preventDefault();
                                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }
                                    else {
                                        if (self.pivot != null) {
                                            (el.attribute("data-m-pivot") != null) ? self.pivot.exact(el.attribute("data-m-pivot")) : self.pivot.next();
                                        }
                                        if (metron.globals["forms"][self.model] != null) {
                                            try {
                                                metron.globals["forms"][self.model].loadForm();
                                            }
                                            catch (e) { }
                                        }
                                        if (self.new_m_inject != null) {
                                            self.new_m_inject();
                                        }
                                    }
                                }, true);
                                break;
                            case "undo":
                                el.addEvent("click", function (e) {
                                    e.preventDefault();
                                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }
                                    else {
                                        self.undoLast();
                                    }
                                    if (self.undo_m_inject != null) {
                                        self.undo_m_inject();
                                    }
                                }, true);
                                el.hide();
                                break;
                            case "download":
                                el.addEvent("click", function (e) {
                                    e.preventDefault();
                                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }
                                    else {
                                        document.location.href = metron.fw.getAppUrl() + "/" + self.model + "/download";
                                    }
                                    if (self.download_m_inject != null) {
                                        self.download_m_inject();
                                    }
                                }, true);
                                break;
                            default:
                                if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                    el.addEvent("click", function (e) {
                                        e.preventDefault();
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    });
                                }
                                break;
                        }
                    });
                });
                self.callListing();
                if (self.init_m_inject != null) {
                    self.init_m_inject();
                }
            }
            return self;
        };
        list.prototype.loadFilters = function (filters) {
            var self = this;
            var promises = [];
            filters.each(function (indx, el) {
                if (el.attribute("data-m-binding") != null) {
                    var binding_1 = el.attribute("data-m-binding");
                    var key_1 = (el.attribute("data-m-key")) != null ? el.attribute("data-m-key") : el.attribute("name");
                    var nm = el.attribute("name");
                    var nText_1 = el.attribute("data-m-text");
                    var options_1 = (el.attribute("data-m-options") != null) ? metron.tools.formatOptions(el.attribute("data-m-options")) : {};
                    var ajx = new RSVP.Promise(function (resolve, reject) {
                        metron.web.get("" + metron.fw.getAPIURL(binding_1) + self.withDefaults(options_1), {}, null, "json", function (data) {
                            data.each(function (i, item) {
                                if (self._filters[key_1] != null && self._filters[key_1] == item[key_1]) {
                                    el.append("<option value=\"" + item[key_1] + "\" selected=\"selected\">" + item[nText_1] + "</option>");
                                }
                                else {
                                    el.append("<option value=\"" + item[key_1] + "\">" + item[nText_1] + "</option>");
                                }
                            });
                            resolve(data);
                        });
                    });
                    promises.push(ajx);
                    el.addEvent("change", function (e) {
                        var fil = self._filters;
                        fil[key_1] = (this.val() == '') ? null : this.val();
                        self._filters = fil;
                        self.currentPageIndex = 1;
                        self.callListing();
                    });
                }
                if (el.attribute("data-m-search") != null) {
                    el.addEvent("click", function (e) {
                        e.preventDefault();
                        var itm = this;
                        var fil = self._filters;
                        var terms = this.attribute("data-m-search").split(";");
                        terms.each(function (i, term) {
                            var parent = itm.parent();
                            fil[term.trim()] = (parent.selectOne("#" + itm.attribute("data-m-search-for")).val() == '') ? null : parent.selectOne("#" + itm.attribute("data-m-search-for")).val();
                        });
                        self._filters = fil;
                        self.currentPageIndex = 1;
                        self.callListing();
                    });
                }
            });
            if (document.selectOne('[data-m-segment="filters"] input[name="Term"]')) {
                document.selectOne('[data-m-segment="filters"] input[name="Term"]').addEvent("change", function (e) {
                    if (document.selectOne('[data-m-segment="filters"] button[title="Search"]')) {
                        document.selectOne('[data-m-segment="filters"] button[title="Search"]').click();
                    }
                });
            }
            RSVP.all(promises).then(function () {
                if (self.loadFilters_m_inject != null) {
                    self.loadFilters_m_inject();
                }
            }).catch(function (reason) {
                console.log("Error: Promise execution failed! " + reason);
            });
        };
        list.prototype.applyViewEvents = function () {
            var self = this;
            self._elem.selectAll("[data-m-action='edit']").each(function (idx, elem) {
                elem.removeEvent("click").addEvent("click", function (e) {
                    e.preventDefault();
                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()] != null) {
                        metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()](elem);
                    }
                    else {
                        var parameters = metron.tools.formatOptions(elem.attribute("data-m-primary"));
                        if (self.pivot != null) {
                            (elem.attribute("data-m-pivot") != null) ? self.pivot.exact(elem.attribute("data-m-pivot")) : self.pivot.next();
                        }
                        if (metron.globals["forms"][self.model] != null) {
                            try {
                                metron.globals["forms"][self.model].loadForm(parameters);
                            }
                            catch (e) { }
                        }
                        if (self.edit_m_inject != null) {
                            self.edit_m_inject();
                        }
                    }
                }, true);
            });
            self._elem.selectAll("[data-m-action='delete']").each(function (idx, elem) {
                elem.removeEvent("click").addEvent("click", function (e) {
                    e.preventDefault();
                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()] != null) {
                        metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()](elem);
                    }
                    else {
                        if (confirm('Are you sure you want to delete this record?')) {
                            var current_1 = this;
                            var parameters = metron.tools.formatOptions(elem.attribute("data-m-primary"));
                            metron.web.remove("" + metron.fw.getAPIURL(self.model) + metron.web.querystringify(parameters), parameters, null, "json", function (data) {
                                if (data instanceof Array) {
                                    data = data[0];
                                }
                                self.recycleBin.push(data);
                                if (current_1.up("tr") != null) {
                                    current_1.up("tr").drop();
                                }
                                else {
                                    current_1.up(".row").drop();
                                }
                                if (self._elem.selectOne("[data-m-action='undo']")) {
                                    self._elem.selectOne("[data-m-action='undo']").show();
                                }
                                if (self.delete_m_inject != null) {
                                    self.delete_m_inject(data);
                                }
                            });
                        }
                    }
                }, true);
            });
            self._elem.selectAll("[data-m-action='sort']").each(function (idx, elem) {
                elem.removeClass("pointer").addClass("pointer");
                elem.removeEvent("click").addEvent("click", function (e) {
                    self.sortOrder = elem.attribute("data-m-col");
                    if (self.sortDirection == "ASC") {
                        self.sortDirection = "DESC";
                    }
                    else {
                        self.sortDirection = "ASC";
                    }
                    self.callListing();
                }, true);
            });
            self._elem.selectAll("[data-m-action]").each(function (idx, elem) {
                if (elem.attribute("data-m-action") != "edit" && elem.attribute("data-m-action") != "delete" && elem.attribute("data-m-action") != "sort" && elem.attribute("data-m-action") != "filter") {
                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()] != null) {
                        elem.removeEvent("click").addEvent("click", function (e) {
                            e.preventDefault();
                            metron.globals.actions[self.model + "_" + elem.attribute("data-m-action").lower()](elem);
                        });
                    }
                }
            });
            if (self.applyViewEvents_m_inject != null) {
                self.applyViewEvents_m_inject();
            }
        };
        list.prototype.withDefaults = function (parameters) {
            var self = this;
            if (Object.keys(self._defaults).length) {
                var local = {};
                for (var k in self._defaults) {
                    if (self._defaults.hasOwnProperty(k)) {
                        local[k] = self._defaults[k];
                    }
                }
                var withDefaults = Object.extend(parameters, local);
                return metron.web.querystringify(metron.tools.normalizeModelData(withDefaults));
            }
            return metron.web.querystringify(metron.tools.normalizeModelData(parameters));
        };
        list.prototype.populateListing = function () {
            var self = this;
            self.clearTable(self._elem.selectOne("[data-m-segment='list']"));
            self.populateTable(self._elem.selectOne("[data-m-segment='list']"));
            self.totalCount = (self._items.length > 0) ? self._items[0]["TotalCount"] : 0;
            self.createPaging(self._elem.selectOne("[data-m-segment='paging']"), self.totalCount);
            self.applyViewEvents();
            if (self.populateListing_m_inject != null) {
                self.populateListing_m_inject();
            }
        };
        list.prototype.undoLast = function () {
            var self = this;
            metron.web.post(metron.fw.getAPIURL(self.model) + "/undo", self.recycleBin.pop(), null, "json", function (data) {
                self.callListing();
            });
            if (self.recycleBin.length == 0) {
                self._elem.selectOne("[data-m-action='undo']").hide();
            }
            if (self.undoLast_m_inject != null) {
                self.undoLast_m_inject();
            }
        };
        list.prototype.formatData = function (item, isTable) {
            if (isTable === void 0) { isTable = true; }
            var self = this;
            return metron.templates.list.row(self._rowTemplate, item, isTable);
        };
        list.prototype.callListing = function () {
            var self = this;
            self.clearAlerts();
            var parameters = Object.extend({ PageIndex: self.currentPageIndex, PageSize: self.pageSize, _SortOrder: self.sortOrder, _SortDirection: self.sortDirection }, self._filters);
            var url = (self.fetchURL != null) ? self.fetchURL : self.model;
            if (!self._elem.isHidden() && self.shouldRoute(self.options)) {
                metron.routing.setRouteUrl(self._name, metron.web.querystringify(metron.tools.normalizeModelData(parameters)));
            }
            metron.web.get("" + metron.fw.getAPIURL(url) + self.withDefaults(parameters), {}, null, "json", function (data) {
                self._items = data;
                self.populateListing();
                if (self.callListing_m_inject != null) {
                    self.callListing_m_inject(data);
                }
            }, function (txt, jsn, xml) {
                self.showAlerts(metron.DANGER, txt, jsn, xml);
            });
        };
        list.prototype.populateTable = function (selector) {
            var self = this;
            var tbody = selector.selectOne("[data-m-type='table-body']");
            var isTable = (tbody.nodeName.lower() == "tbody") ? true : false;
            self._items.each(function (idx, item) {
                selector.selectOne("[data-m-type='table-body']").append(self.formatData(item, isTable));
            });
            tbody.attribute("data-m-state", "show");
            if (isTable) {
                tbody.show("table-row-group");
            }
            else {
                tbody.show();
            }
        };
        list.prototype.clearTable = function (selector) {
            var self = this;
            if (String.isNullOrEmpty(self._rowTemplate)) {
                self._rowTemplate = selector.selectOne("[data-m-type='table-body'] [data-m-action='repeat']").outerHTML;
            }
            selector.selectOne("[data-m-type='table-body']").empty();
        };
        list.prototype.getRows = function (selector) {
            return document.selectAll(selector + " [data-m-type='table-body'] [data-m-type='row']").length;
        };
        list.prototype.setupPagingEvents = function (selector, filters) {
            var self = this;
            selector.selectOne("li > a[title='Previous']").removeEvent("click").addEvent("click", function (e) {
                e.preventDefault();
                self.pageListing(self.getPreviousPage(), filters);
            }, true);
            selector.selectOne("li > a[title='Next']").removeEvent("click").addEvent("click", function (e) {
                e.preventDefault();
                self.pageListing(self.getNextPage(), filters);
            }, true);
            selector.selectOne("li > a[title='First']").removeEvent("click").addEvent("click", function (e) {
                e.preventDefault();
                self.pageListing(1, filters);
            }, true);
            selector.selectOne("li > a[title='Last']").removeEvent("click").addEvent("click", function (e) {
                e.preventDefault();
                self.pageListing(self.totalPageSize, filters);
            }, true);
        };
        list.prototype.createPaging = function (selector, totalCount, filters) {
            var self = this;
            if (selector == null) {
                return;
            }
            if (self.currentPageIndex != null && self.pageSize != null) {
                self.totalPageSize = self.calculateTotalPageSize(totalCount);
                var startPage = ((parseInt(this.currentPageIndex.toString(), 10) - 5) < 1) ? 1 : (parseInt(this.currentPageIndex.toString(), 10) - 5);
                var endPage = ((parseInt(this.currentPageIndex.toString(), 10) + 5) > this.totalPageSize) ? this.totalPageSize : (parseInt(this.currentPageIndex.toString(), 10) + 5);
                self.setupPagingEvents(selector, filters);
                selector.selectAll("li").each(function (idx, elem) {
                    if (elem.first("a").attribute("title") != "Previous" && elem.first("a").attribute("title") != "Next" && elem.first("a").attribute("title") != "First" && elem.first("a").attribute("title") != "Last") {
                        elem.drop();
                    }
                });
                for (var i = 1; i <= self.totalPageSize; i++) {
                    if (i < startPage || i > endPage) {
                        continue;
                    }
                    var li = document.create("<li />");
                    var idx = i;
                    var link = document.create("<a class=\"button button-outline\">" + idx + "</a>").attribute("href", "#").attribute("title", idx).addEvent("click", function (e) {
                        e.preventDefault();
                        self.pageListing(this.attribute("title"), filters);
                    });
                    li.appendChild(link);
                    selector.insertBefore(li, selector.selectOne("li > a[title='Next']").parent());
                }
                if (self.totalPageSize > 0) {
                    selector.selectOne("li > a[title='" + self.currentPageIndex + "']").removeClass("button-outline").addClass("button-clear");
                }
                if (selector.selectAll("li").length <= 5) {
                    selector.hide();
                }
                else {
                    selector.show();
                }
                if (self._elem.selectOne("[data-m-segment='recordcount']") != null) {
                    self._elem.selectOne("[data-m-segment='recordcount']").innerHTML = "<label class=\"record-count\">of " + this.totalPageSize + " Pages (" + totalCount + " Total Records)</label>";
                }
            }
            else {
                selector.hide();
            }
            self.applyPageSizeEvents(selector);
        };
        list.prototype.applyPageSizeEvents = function (selector) {
            var self = this;
            var parent = selector.parent();
            var control = parent.selectOne("[data-m-segment='controls'] [data-m-segment='paging']");
            control.val(self.pageSize);
            control.addEvent("change", function (e) {
                self.pageSize = control.val();
                metron.config["config.options.pageSize"] = self.pageSize;
                var store = new metron.store(metron.DB, metron.DBVERSION, metron.STORE);
                store.init().then(function (result) {
                    return store.setItem("metron.config", metron.config);
                }).then(function (result) {
                    self.callListing();
                }).catch(function (reason) {
                    console.log("Error: Failed to access storage. " + reason);
                    self.callListing();
                });
            }, true);
        };
        list.prototype.calculateTotalPageSize = function (totalCount) {
            return Math.ceil(totalCount / this.pageSize);
        };
        list.prototype.pageListing = function (idx, filters) {
            this.currentPageIndex = idx;
            this.callListing();
        };
        list.prototype.getPreviousPage = function () {
            return (this.currentPageIndex === 0) ? this.currentPageIndex : (parseInt(this.currentPageIndex, 10) - 1);
        };
        list.prototype.getNextPage = function () {
            return (this.currentPageIndex === this.totalPageSize) ? this.currentPageIndex : (parseInt(this.currentPageIndex, 10) + 1);
        };
        list.prototype.setFilters = function () {
            var self = this;
            var elem = (self._elem != null) ? self._elem : document.selectOne("[data-m-type='list'][data-m-model='" + self.model + "']");
            var page = (elem != null) ? elem.attribute("data-m-page") : null;
            var routeName = metron.routing.getRouteName();
            var qs = metron.web.querystring();
            if (qs != "") {
                self._filters = metron.tools.formatOptions(qs, metron.OptionTypes.QUERYSTRING);
            }
            var hash = metron.routing.getRouteUrl(self._filters);
            if (hash != null) {
                self.pageSize = (hash["PageSize"] != null) ? hash["PageSize"] : self.pageSize;
                self.currentPageIndex = (hash["PageIndex"] != null) ? hash["PageIndex"] : self.currentPageIndex;
                self.sortOrder = (hash["_SortOrder"] != null) ? hash["_SortOrder"] : self.sortOrder;
                self.sortDirection = (hash["_SortDirection"] != null) ? hash["_SortDirection"] : self.sortDirection;
                delete hash["PageSize"];
                delete hash["PageIndex"];
                delete hash["_SortOrder"];
                delete hash["_SortDirection"];
                if (routeName == null || routeName == page) {
                    for (var h in hash) {
                        if (hash.hasOwnProperty(h)) {
                            if (self._filters[h] == null) {
                                self._filters[h] = hash[h];
                            }
                        }
                    }
                }
            }
        };
        Object.defineProperty(list.prototype, "elem", {
            get: function () {
                return this._elem;
            },
            set: function (f) {
                this._elem = f;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(list.prototype, "form", {
            get: function () {
                return this._form;
            },
            set: function (f) {
                this._form = f;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(list.prototype, "filters", {
            get: function () {
                return this._filters;
            },
            set: function (f) {
                this._filters = f;
            },
            enumerable: true,
            configurable: true
        });
        return list;
    }(metron.base));
    metron.list = list;
})(metron || (metron = {}));
var metron;
(function (metron) {
    var forms = (function () {
        function forms() {
        }
        forms.bindAll = function (callback) {
            var sections = document.selectAll("[data-m-type='form']");
            for (var i = 0; i < sections.length; i++) {
                var section = sections[i];
                if (section.attribute("data-m-autoload") == null || section.attribute("data-m-autoload") == "true") {
                    var model = section.attribute("data-m-model");
                    var mID = section.attribute("id");
                    var gTypeName = (mID != null) ? mID + "_" + model : model;
                    if (metron.globals["forms"][gTypeName] == null) {
                        var f = new form(model);
                        f.id = mID;
                        f.gTypeName = gTypeName;
                        f.init();
                    }
                }
            }
            if (callback != null) {
                callback();
            }
        };
        return forms;
    }());
    metron.forms = forms;
    var form = (function (_super) {
        __extends(form, _super);
        function form(model, options) {
            var _this = _super.call(this, model, metron.FORM) || this;
            _this.model = model;
            _this.options = options;
            _this._fields = [];
            _this._defaults = (metron.config["config.forms.defaults"] != null) ? metron.config["config.forms.defaults"] : [];
            _this.hasLoaded = false;
            var self = _this;
            self.id = (options != null) ? options.mID : null;
            self.gTypeName = (options != null && options.mID != null) ? options.mID + "_" + model : model;
            metron.globals["forms"][self.gTypeName] = self;
            self._elem = (self.id != null) ? document.selectOne("#" + self.id) : document.selectOne("[data-m-type='form'][data-m-model='" + self.model + "']");
            return _this;
        }
        form.prototype.loadDefaults = function () {
            var self = this;
            if (self._defaults != null && self._defaults.length > 0) {
                for (var i = 0; i < self._defaults.length; i++) {
                    var pair = self._defaults[i];
                    for (var k in pair) {
                        if (pair.hasOwnProperty(k)) {
                            var v = pair[k];
                            if (k.contains(self.model + "_") && document.selectOne("#" + k) != null) {
                                document.selectOne("#" + k).val(v);
                            }
                            else if (!k.contains("_") && document.selectOne("#" + self.model + "_" + k) != null) {
                                document.selectOne("#" + self.model + "_" + k).val(v);
                            }
                        }
                    }
                }
            }
        };
        form.prototype.init = function (toggle) {
            if (toggle === void 0) { toggle = false; }
            var self = this;
            self.hasLoaded = true;
            if (self._elem != null) {
                self.pivot = self.attachPivot(self._elem);
                self._name = self._elem.attribute("data-m-page");
                var selects = self._elem.selectAll("select");
                self.loadSelects(selects, function () {
                    var parameters;
                    var defaults;
                    var qs = metron.web.querystring();
                    if (qs != "") {
                        defaults = metron.tools.formatOptions(qs, metron.OptionTypes.QUERYSTRING);
                    }
                    if (metron.globals.firstLoad) {
                        parameters = metron.routing.getRouteUrl({ "PageSize": 1, "PageIndex": 1, "_SortOrder": 1, "_SortDirection": 1 });
                    }
                    self.loadForm(parameters, defaults);
                });
                var controlBlocks = self._elem.selectAll("[data-m-segment='controls']");
                controlBlocks.each(function (idx, elem) {
                    var actions = elem.selectAll("[data-m-action]");
                    actions.each(function (indx, el) {
                        switch (el.attribute("data-m-action").lower()) {
                            case "save":
                                el.addEvent("click", function (e) {
                                    el.attribute("disabled", "disabled");
                                    e.preventDefault();
                                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }
                                    else {
                                        if (self.isValid()) {
                                            var parameters_1 = {};
                                            var hasPrimary_1 = false;
                                            self.elem.selectAll("input, select, textarea").each(function (idx, elem) {
                                                if (elem.attribute("data-m-autocomplete") != null && elem.val() != "") {
                                                    parameters_1[elem.attribute("name")] = metron.globals.autolists[elem.attribute("id")][elem.val()];
                                                }
                                                else {
                                                    parameters_1[elem.attribute("name")] = elem.val();
                                                }
                                                if (elem.attribute("data-m-primary") != null && elem.attribute("data-m-primary").toBool() && elem.val() != "") {
                                                    hasPrimary_1 = true;
                                                }
                                            });
                                            if (!hasPrimary_1) {
                                                metron.web.post("" + metron.fw.getAPIURL(self.model), parameters_1, null, "json", function (data) {
                                                    self.save(data, el.attribute("data-m-pivot"), el);
                                                }, function (txt, jsn, xml) {
                                                    self.showAlerts(metron.DANGER, txt, jsn, xml);
                                                    el.removeAttribute("disabled");
                                                });
                                            }
                                            else {
                                                metron.web.put("" + metron.fw.getAPIURL(self.model), parameters_1, null, "json", function (data) {
                                                    self.save(data, el.attribute("data-m-pivot"), el);
                                                }, function (txt, jsn, xml) {
                                                    self.showAlerts(metron.DANGER, txt, jsn, xml);
                                                    el.removeAttribute("disabled");
                                                });
                                            }
                                        }
                                        else {
                                            el.removeAttribute("disabled");
                                        }
                                    }
                                }, true);
                                break;
                            case "cancel":
                                el.addEvent("click", function (e) {
                                    e.preventDefault();
                                    if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }
                                    else {
                                        self.clearForm();
                                        if (self.pivot != null) {
                                            (el.attribute("data-m-pivot") != null) ? self.pivot.exact(el.attribute("data-m-pivot")) : self.pivot.previous();
                                        }
                                        if (metron.globals["lists"][self.model] != null) {
                                            metron.globals["lists"][self.model].callListing();
                                        }
                                        if (self.cancel_m_inject != null) {
                                            self.cancel_m_inject();
                                        }
                                    }
                                }, true);
                                break;
                            default:
                                if (metron.globals.actions != null && metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()] != null) {
                                    el.addEvent("click", function (e) {
                                        e.preventDefault();
                                        metron.globals.actions[self.model + "_" + el.attribute("data-m-action").lower()]();
                                    }, true);
                                }
                                break;
                        }
                    });
                });
                if (self.init_m_inject != null) {
                    self.init_m_inject();
                }
            }
            return self;
        };
        form.prototype.save = function (data, pivotPosition, saveElement) {
            var self = this;
            self.elem.selectAll("[data-m-primary]").each(function (idx, elem) {
                elem.val(data[elem.attribute("name")]);
            });
            if (self.pivot != null) {
                (pivotPosition != null) ? self.pivot.exact(pivotPosition) : self.pivot.previous();
            }
            if (metron.globals["lists"][self.model] != null) {
                try {
                    metron.globals["lists"][self.model].callListing();
                }
                catch (e) { }
            }
            saveElement.removeAttribute("disabled");
            if (self.save_m_inject != null) {
                self.save_m_inject(data);
            }
        };
        form.prototype.loadForm = function (parameters, defaults) {
            var self = this;
            self.clearForm();
            if (!self._elem.isHidden() && self.shouldRoute(self.options)) {
                metron.routing.setRouteUrl(self._name, metron.web.querystringify(parameters), true);
            }
            if (defaults != null) {
                for (var prop in defaults) {
                    if (defaults.hasOwnProperty(prop) && defaults[prop] != null && document.selectOne("#" + self.model + "_" + prop) != null) {
                        if (document.selectOne("#" + self.model + "_" + prop).attribute("data-m-autocomplete") != null) {
                            document.selectOne("#" + self.model + "_" + prop).val(defaults[document.selectOne("#" + self.model + "_" + prop).attribute("data-m-display-text")]);
                        }
                        else {
                            document.selectOne("#" + self.model + "_" + prop).val(defaults[prop]);
                        }
                    }
                }
            }
            if (parameters != null && Object.keys(parameters).length > 0) {
                metron.web.get("" + metron.fw.getAPIURL(self.model) + metron.web.querystringify(parameters), parameters, null, "json", function (data) {
                    if (data instanceof Array) {
                        data = data[0];
                    }
                    for (var prop in data) {
                        if (self.id == null) {
                            if (data.hasOwnProperty(prop) && data[prop] != null && document.selectOne("#" + self.model + "_" + prop) != null) {
                                if (document.selectOne("#" + self.model + "_" + prop).attribute("data-m-autocomplete") != null) {
                                    document.selectOne("#" + self.model + "_" + prop).val(data[document.selectOne("#" + self.model + "_" + prop).attribute("data-m-display-text")]);
                                }
                                else {
                                    document.selectOne("#" + self.model + "_" + prop).val(data[prop]);
                                }
                            }
                        }
                        else {
                            if (data.hasOwnProperty(prop) && data[prop] != null && document.selectOne("#" + self.id + " > fieldset > #" + self.model + "_" + prop) != null) {
                                if (document.selectOne("#" + self.model + "_" + prop).attribute("data-m-autocomplete") != null) {
                                    document.selectOne("#" + self.id + " > fieldset > #" + self.model + "_" + prop).val(data[document.selectOne("#" + self.model + "_" + prop).attribute("data-m-display-text")]);
                                }
                                else {
                                    document.selectOne("#" + self.id + " > fieldset > #" + self.model + "_" + prop).val(data[prop]);
                                }
                            }
                        }
                    }
                    if (self.loadForm_m_inject != null) {
                        self.loadForm_m_inject(data);
                    }
                });
            }
        };
        form.prototype.loadSelects = function (selects, callback) {
            var self = this;
            var promises = [];
            selects.each(function (indx, el) {
                if (el.attribute("data-m-binding") != null && el.selectAll("option").length <= 1) {
                    var binding_2 = el.attribute("data-m-binding");
                    var key_2 = (el.attribute("data-m-key")) != null ? el.attribute("data-m-key") : el.attribute("name");
                    var nm_1 = el.attribute("name");
                    var nText_2 = el.attribute("data-m-text");
                    var options_2 = (el.attribute("data-m-options") != null) ? metron.tools.formatOptions(el.attribute("data-m-options")) : {};
                    var ajx = new RSVP.Promise(function (resolve, reject) {
                        metron.web.get("" + metron.fw.getAPIURL(binding_2) + metron.web.querystringify(options_2), {}, null, "json", function (data) {
                            data.each(function (i, item) {
                                self._elem.selectOne("#" + self.model + "_" + nm_1).append("<option value=\"" + item[key_2] + "\">" + item[nText_2] + "</option>");
                            });
                            resolve(data);
                        });
                    });
                    promises.push(ajx);
                }
            });
            RSVP.all(promises).then(function () {
                if (callback != null) {
                    callback();
                }
                if (self.loadSelects_m_inject != null) {
                    self.loadSelects_m_inject();
                }
            }).catch(function (reason) {
                console.log("Error: Promise execution failed!");
            });
        };
        form.prototype.clearForm = function (selector, callback) {
            var self = this;
            var f = (self._elem != null) ? self._elem : document.selectOne(selector);
            document.selectAll(".error").each(function (idx, elem) {
                elem.removeClass("error");
            });
            document.selectAll(".label-error").each(function (idx, elem) {
                elem.removeClass("label-error");
            });
            f.selectAll("input:not([data-m-ignore='true']), select:not([data-m-ignore='true'])").each(function (idx, elem) {
                elem.val("");
            });
            f.selectAll("textarea:not([data-m-ignore='true'])").each(function (idx, elem) {
                elem.val("");
            });
            f.selectAll("input[type='checkbox']:not([data-m-ignore='true'])").each(function (idx, elem) {
                elem.val("");
            });
            self.clearAlerts();
            self.loadDefaults();
            if (callback != null) {
                callback();
            }
            if (self.clearForm_m_inject != null) {
                self.clearForm_m_inject();
            }
        };
        form.prototype.isValid = function (selector) {
            var self = this;
            self.clearAlerts();
            var result = "";
            var f = (self._elem != null) ? self._elem : document.selectOne(selector);
            f.selectAll(".error").each(function (idx, elem) {
                elem.removeClass("error");
            });
            f.selectAll(".label-error").each(function (idx, elem) {
                elem.removeClass("label-error");
            });
            var isValid = true;
            var required = f.selectAll("[required='required']");
            required.each(function (idx, elem) {
                if (elem.val() == null || elem.val().trim() === "") {
                    isValid = false;
                    elem.addClass("error");
                    if (f.selectOne("label[for='" + elem.attribute("id") + "']") != null) {
                        f.selectOne("label[for='" + elem.attribute("id") + "']").addClass("label-error");
                    }
                    if (f.selectOne("label[for='" + elem.attribute("id") + "']") != null && f.selectOne("label[for='" + elem.attribute("id") + "']").innerText != "") {
                        result += "<p>" + f.selectOne("label[for='" + elem.attribute("id") + "']").innerText + " is a required field.</p>";
                    }
                    else {
                        result += "<p>[" + elem.attribute("name") + "] is a required field.</p>";
                    }
                }
            });
            if (!isValid) {
                self.showAlerts(metron.DANGER, result);
                window.scrollTo(0, 0);
            }
            return isValid;
        };
        Object.defineProperty(form.prototype, "elem", {
            get: function () {
                return this._elem;
            },
            set: function (f) {
                this._elem = f;
            },
            enumerable: true,
            configurable: true
        });
        return form;
    }(metron.base));
    metron.form = form;
})(metron || (metron = {}));
var metron;
(function (metron) {
    var views = (function () {
        function views() {
        }
        views.bindAll = function () {
        };
        return views;
    }());
    metron.views = views;
    var view = (function (_super) {
        __extends(view, _super);
        function view(model) {
            var _this = _super.call(this, model, metron.VIEW) || this;
            _this.model = model;
            var self = _this;
            return _this;
        }
        view.prototype.init = function () {
            var self = this;
            self._elem = (self.id != null) ? document.selectOne("#" + self.id) : document.selectOne("[data-m-type='view'][data-m-model='" + self.model + "']");
            if (self._elem != null) {
                self.pivot = self.attachPivot(self._elem);
                self._name = self._elem.attribute("[data-m-page]");
                var querystring = metron.web.querystring();
                self.callView(querystring);
            }
            return self;
        };
        view.prototype.callView = function (querystring) {
            var self = this;
            var parameters = {};
            metron.web.get("" + metron.fw.getAPIURL(self.model) + querystring, parameters, null, "json", function (data) {
                if (data instanceof Array) {
                    data = data[0];
                }
                for (var prop in data) {
                    if (data.hasOwnProperty(prop) && data[prop] != null && document.selectOne("#View_" + self.model + "_" + prop) != null) {
                        document.selectOne("#View_" + self.model + "_" + prop).innerText = data[prop];
                    }
                }
            });
        };
        Object.defineProperty(view.prototype, "elem", {
            get: function () {
                return this._elem;
            },
            set: function (v) {
                this._elem = v;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(view.prototype, "form", {
            get: function () {
                return this._form;
            },
            set: function (f) {
                this._form = f;
            },
            enumerable: true,
            configurable: true
        });
        return view;
    }(metron.base));
    metron.view = view;
})(metron || (metron = {}));
var metron;
(function (metron) {
    var templates;
    (function (templates) {
        function load(includesFile) {
            var url = metron.fw.getAppUrl() + "/" + includesFile;
            return new RSVP.Promise(function (resolve, reject) {
                metron.web.ajax(url, {}, "GET", true, "text/html", "text", function (content) {
                    resolve(content);
                }, function (txt, jsn, xml) {
                    console.log("Error loading " + includesFile + ": " + txt);
                    reject(txt);
                });
            });
        }
        templates.load = load;
        var list;
        (function (list) {
            function row(template, item, isTable) {
                if (isTable === void 0) { isTable = true; }
                var result = template;
                for (var k in item) {
                    if (item.hasOwnProperty(k)) {
                        var replacement = "{{" + k + "}}";
                        result = result.replace(new RegExp(replacement, "g"), (item[k] != null && item[k] != "null") ? item[k] : "");
                    }
                }
                var doc = document.createElement((isTable ? "tbody" : "div"));
                doc.innerHTML = result;
                doc.selectAll("[data-m-format]").each(function (idx, elem) {
                    var options = (elem.attribute("data-m-options") != null) ? metron.tools.formatOptions(elem.attribute("data-m-options")) : null;
                    if (elem.firstElementChild == null) {
                        elem.innerText = format(elem.attribute("data-m-format"), elem.innerText, options);
                    }
                    else {
                        format(elem.attribute("data-m-format"), elem, options);
                    }
                });
                return doc.innerHTML;
            }
            list.row = row;
            function format(type, val, options) {
                switch (type.lower()) {
                    case "yesno":
                        return metron.tools.formatBoolean(val);
                    case "datetime":
                        return metron.tools.formatDateTime(val);
                    case "date":
                        return metron.tools.formatDate(val);
                    case "time":
                        return metron.tools.formatTime(val);
                    case "formatmessage":
                        return metron.tools.formatMessage(val, options["length"]);
                    case "decimal":
                        return metron.tools.formatDecimal(val);
                    default:
                        return metron.globals[type](val, options);
                }
            }
            list.format = format;
        })(list = templates.list || (templates.list = {}));
        var markdown;
        (function (markdown) {
            function toHTML(src) {
                var html = "";
                function escape(text) {
                    return new Option(text).innerHTML;
                }
                function inlineEscape(str) {
                    return str.replace(/!\[([^\]]*)]\(([^(]+)\)/g, '<img alt="$1" src="$2" />')
                        .replace(/\[([^\]]+)]\(([^(]+)\)/g, '$1'.link('$2'))
                        .replace(/`([^`]+)`/g, function (match, p1, offset, string) {
                        return "<code>" + escape(p1) + "</code>";
                    })
                        .replace(/\*\*([^*]+)\*\*/g, '<strong>$1</strong>')
                        .replace(/\*([^*]+)\*/g, '<em>$1</em>')
                        .replace(/  \n/g, '<br />');
                }
                function processWrappedMarkdown(prependType, line) {
                    return prependType[1] + ("\n" + line)
                        .split(prependType[0])
                        .slice(1)
                        .map(prependType[3] ? escape : inlineEscape)
                        .join(prependType[3] || "</li>\n<li>") + prependType[2];
                }
                function processSemanticMarkdown(char, line) {
                    return (char == "#")
                        ? ("<h" + (char = line.indexOf(" ")) + ">" + inlineEscape(line.slice(char + 1)) + "</h" + char + ">")
                        : (char == "<" ? line : "<p>" + inlineEscape(line) + "</p>");
                }
                src.replace(/&gt;/g, ">").replace(/^\s+|\r|\s+$/g, "").replace(/\t/g, "    ").split(/\n\n+/).forEach(function (line, idx, lines) {
                    var char = line[0];
                    var prependType = {
                        '*': [/\n\* /, "<ul><li>", "</li></ul>"],
                        '1': [/\n[1-9]\d*\.? /, "<ol><li>", "</li></ol>"],
                        ' ': [/\n    /, "<pre><code>", "</pre></code>", "\n"],
                        '>': [/\n> /, "<blockquote>", "</blockquote>", "\n"],
                    }[char];
                    html += prependType ? processWrappedMarkdown(prependType, line) : processSemanticMarkdown(char, line);
                });
                return html;
            }
            markdown.toHTML = toHTML;
        })(markdown = templates.markdown || (templates.markdown = {}));
        var master;
        (function (master) {
            function hasMaster(page) {
                if (page.match(/\{\{m:master=\"(.*)\"\}\}/g) != null && page.match(/\{\{m:master=\"(.*)\"\}\}/g).length > 0) {
                    return true;
                }
                return false;
            }
            master.hasMaster = hasMaster;
            function loadMaster(page) {
                return new RSVP.Promise(function (resolve, reject) {
                    if (master.hasMaster(page)) {
                        var root_1 = metron.tools.getMatching(page, /\{\{m:root=\"(.*)\"\}\}/g);
                        var fileName_1 = metron.tools.getMatching(page, /\{\{m:master=\"(.*)\"\}\}/g);
                        metron.web.get(root_1 + "/" + fileName_1, {}, "text/html", "text", function (resp) {
                            metron.templates.master.merge(resp);
                            resolve(resp);
                        }, function (err) {
                            document.documentElement.append("<h1>Error: Failed to load [" + root_1 + "/" + fileName_1 + "].</h1><p>" + err + "</p>");
                            reject(err);
                        });
                    }
                    else {
                        resolve();
                    }
                });
            }
            master.loadMaster = loadMaster;
            function merge(template) {
                function _copyAttributes(src, elemName) {
                    for (var i = 0; i < src.attributes.length; i++) {
                        document.documentElement.querySelector(elemName).attribute(src.attributes[i].name, src.attributes[i].value);
                    }
                }
                var placeholder = document.createElement("html");
                var content = getContentRoot();
                placeholder.innerHTML = "<metron>" + template.replace("{{m:content}}", content).replace(/head/g, "mhead").replace(/body/g, "mbody").replace(/mheader/g, "header") + "</metron>";
                document.documentElement.empty();
                if (document.documentElement.hasChildNodes()) {
                    document.querySelector("head").innerHTML = placeholder.querySelector("mhead").innerHTML;
                    _copyAttributes(placeholder.querySelector("mhead"), "head");
                    document.querySelector("body").innerHTML = placeholder.querySelector("mbody").innerHTML;
                    _copyAttributes(placeholder.querySelector("mbody"), "body");
                }
                else {
                    document.documentElement.append(placeholder.innerHTML);
                }
            }
            master.merge = merge;
            function getContentRoot() {
                if (document.documentElement.querySelector("body") != null) {
                    return document.documentElement.querySelector("body").innerHTML.replace(/\{\{m:root=\"(.*)\"\}\}/g, "").replace(/\{\{m:master=\"(.*)\"\}\}/g, "");
                }
                return document.documentElement.innerHTML.replace(/\{\{m:root=\"(.*)\"\}\}/g, "").replace(/\{\{m:master=\"(.*)\"\}\}/g, "");
            }
            master.getContentRoot = getContentRoot;
        })(master = templates.master || (templates.master = {}));
        function register(n, func) {
            metron.globals[n] = func;
        }
        templates.register = register;
    })(templates = metron.templates || (metron.templates = {}));
})(metron || (metron = {}));
//# sourceMappingURL=metron.js.map