export declare type AjaxRequest = string | JSON | XMLDocument;
export interface Dictionary {
    setItem: (key: string, value: any) => void;
    getItem: (key: string) => any;
    hasItem: (key: string) => boolean;
    removeItem: (key: string) => any;
    keys: () => Array<string>;
    values: () => Array<any>;
    each: (callback: Function) => void;
    clear: () => void;
}
export interface Ajax {
    url: string;
    method: string;
    contentType: string;
    dataType: string;
    data: any;
    async: boolean;
    request: XMLHttpRequest;
    success?: (callback: Function) => XMLHttpRequest;
    error?: (callback: Function) => XMLHttpRequest;
    always?: (callback: Function) => XMLHttpRequest;
    send?: () => void;
}
export interface Pivot {
    parent: HTMLElement;
    current: Element;
    next: Element;
    previous: Element;
}
export interface IBaseOptions {
    id?: string;
    hasRouting?: boolean;
}
export interface ListOptions extends IBaseOptions {
}
export interface FormOptions extends IBaseOptions {
}
export declare enum OptionTypes {
    QUERYSTRING = 1,
    KEYVALUE = 2,
}
export interface EventFunction {
    [name: string]: Function;
}
export declare enum Event {
    INIT = 0,
    LOAD_FILTERS = 1,
    APPLY_VIEW_EVENTS = 2,
    POPULATE_LISTING = 3,
    UNDO_LAST = 4,
    CALL_LISTING = 5,
    SAVE = 6,
    LOAD_FORM = 7,
    LOAD_SELECTS = 8,
    CLEAR_FORM = 9,
    NEW = 10,
    UNDO = 11,
    DOWNLOAD = 12,
    EDIT = 13,
    DELETE = 14,
    CANCEL = 15,
    SAVING = 16,
}
export declare const LIST = "list";
export declare const LOOKUP = "lookup";
export declare const FORM = "form";
export declare const VIEW = "view";
export declare const INFO = "info";
export declare const WARNING = "warning";
export declare const DANGER = "danger";
export declare const SUCCESS = "success";
export declare const DB = "metron.db";
export declare const DBVERSION = 1;
export declare const STORE = "metron.store";
export declare class m {
    static config: any;
    static globals: any;
}
