(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./base", "./schema", "./web", "./routing"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const base_1 = require("./base");
    const schema_1 = require("./schema");
    const web_1 = require("./web");
    const routing_1 = require("./routing");
    class views {
        static bindAll() {
            let sections = document.querySelectorAll("[data-m-type='view']");
            for (let i = 0; i < sections.length; i++) {
                let section = sections[i];
                if (section.attribute("data-m-autoload") == null || section.attribute("data-m-autoload") == "true") {
                    let model = section.attribute("data-m-model");
                    if (schema_1.m.globals["views"][model] == null) {
                        let v = new view(model).init();
                    }
                }
            }
        }
    }
    exports.views = views;
    class view extends base_1.base {
        constructor(model) {
            super(model, schema_1.VIEW);
            this.model = model;
            var self = this;
        }
        init() {
            var self = this;
            self._elem = (self.id != null) ? document.querySelector(`#${self.id}`) : document.querySelector(`[data-m-type='view'][data-m-model='${self.model}']`);
            if (self._elem != null) {
                self.pivot = self.attachPivot(self._elem);
                self._name = self._elem.attribute("[data-m-page]");
                let querystring = web_1.web.querystring();
                self.callView(querystring);
            }
            return self;
        }
        callView(querystring) {
            var self = this;
            let parameters = {};
            web_1.web.get(`${routing_1.routing.getAPIURL(self.model)}${querystring}`, parameters, null, "json", function (data) {
                if (data instanceof Array) {
                    data = data[0];
                }
                self._elem.innerHTML = self.formatData(data, false);
                for (let prop in data) {
                    if (data.hasOwnProperty(prop) && data[prop] != null && document.querySelector(`#View_${self.model}_${prop}`) != null) {
                        document.querySelector(`#View_${self.model}_${prop}`).innerText = data[prop];
                    }
                }
            });
        }
        get elem() {
            return this._elem;
        }
        set elem(v) {
            this._elem = v;
        }
        get form() {
            return this._form;
        }
        set form(f) {
            this._form = f;
        }
    }
    exports.view = view;
});
//# sourceMappingURL=views.js.map